//+--------------------------------------------------------------------------------------------+
//|                                                                      PALLine Spiker EA.mq4 |
//|                                            Copyright  2010, Adeo <adeomercatus@yahoo.com> |
//|                                    Programming by Serega Lykov, http://mtexperts.narod.ru/ |
//|                                             Strategy description in file "PLS20110112.pdf" |
//+--------------------------------------------------------------------------------------------+
// mod001 - release of the EA

#property copyright "Copyright  2010, Adeo"
#property link      "adeomercatus@yahoo.com"

//---- constant values ------------------------------------------------------------------------+
#define ExpertComment            "PLS"        // comment for orders of EA
#define FolderName_Expert        "PALLine Spiker"
#define FolderName_Screenshots   "Screenshots"
#define ScreenshotSizeX          1024
#define ScreenshotSizeY          768
#define ScreenshotStartBar       -1
#define ScreenshotChartScale     -1
#define ScreenshotChartMode      -1
#define FolderName_Logs          "Logs"
#define FileName_OrdersHistory   "OrdersHistory"
#define NumberTicketsInArray     20
#define CSVFile_Separator        ';'
#define ExpertName               "PALLine Spiker"
#define EmailSubjectOpen         "New Trade Information"
#define EmailSubjectClose        "New Trade Information"
#define SC_Label_Corner          3
#define SC_Label_OffsetX         10
#define SC_Label_OffsetY         10
#define SC_Label_FontSize        20
#define SC_Label_FontName        "Arial Bold"
#define SC_Label_Color           Red
#define SC_Label_Text            "Slow Trade! The EA don\'t open a new orders."
#define QT_Label_Corner          3
#define QT_Label_OffsetX         10
#define QT_Label_OffsetY         40
#define QT_Label_FontSize        20
#define QT_Label_FontName        "Arial Bold"
#define QT_Label_Color           Gold
#define QT_Label_Text_1          "QuietTime! ("
#define QT_Label_Text_2          " bars)."

//---- external parameters --------------------------------------------------------------------+
extern string _____Trade_Options____          = "---------------------------------------------";
extern int    SlowCount                       = 2;     // maximum number of slow trades to stop trade
extern int    Latency                         = 1500;  // milliseconds of latency to define a slow trade 
extern bool   ResetSlowTrade                  = false; // true = reset toggle to start trade again after a slow trade stop (allow open a new orders)
extern int    QuietTime                       = 96;    // after loss trade stop trade in during QuietTime bars; 0 = option is disabled
extern double PALLine_LowThreshold            = -50;   // value of indicator PAL for Buy-signal; for Sell-signal use value PALLine_HighThreshold = 0 - PALLine_LowThreshold
extern int    StopMode_0_2                    = 0;     // [0-2] define a stop mode: 0 = StopLoss and TakeProfit; 1 = StopLoss, TakeProfit and TrailingStop; 2 = StopLoss, TakeProfit, TrailingStop and "partial closing at start trailing stop"
extern double StopLoss                        = 20;    // stop-loss (in pips); 0 = without stop-loss
extern double TakeProfit                      = 20;    // take profit (in pips); 0 = without take profit
extern double TrailingStop_Distance           = 0;     // [used in mode StopMode_0_2 = 1 or 2] distance of trailing stop from current price (in pips); 0 = without trailing stop (option is disabled); -1 = value from parameter StopLoss
extern double TrailingStop_CloseLotsPercent   = 50;    // [used in mode StopMode_0_2 = 2] percents of lots of order that should be closed at start trailing stop
   //---- parameters of MM --------------------------------------------------------------------+
extern string ____Size_of_lots______          = "---------------------------------------------";
extern bool   UseMM                           = false;  // enable/disable autocalculation for size of lots: false = constant size of lots (value of parameter "Lots"); true = calculate by percent from FreeMargin (parameter "LotsRiskReductor")
extern double Lots                            = 0.1;    // size of lots (use if UseMM = false)
extern double LotsRiskReductor                = 1.5;    // percent from FreeMargin that will used for open new order (use if UseMM = true)
extern double MaxLots                         = 1000;   // maximal size of lots for one order that possible to trade for EA
   //---- parameters of TradingTime -----------------------------------------------------------+
extern string _____Trading_Time_____          = "---------------------------------------------";
extern bool   UseTradingHours                 = false; // true = the filters "trading interval of time"; value true - the filters is used, false - is not used.
extern bool   TradeAsianMarket                = false; // enable/disable filter "trading interval of time #1"
extern int    Asian_StartTradeHour            = 0;     // hour, when will start a trading interval #1 (time of the Terminal)
extern int    Asian_StartTradeMinute          = 0;     // minute, when will start a trading interval #1
extern int    Asian_FinishTradeHour           = 8;     // hour, when finishs a trading interval #1 (time of the Terminal)
extern int    Asian_FinishTradeMinute         = 0;     // minute, when finishs a trading interval #1
extern bool   TradeEuropeanMarket             = false; // enable/disable filter "trading interval of time #2"
extern int    European_StartTradeHour         = 8;     // hour, when will start a trading interval #2 (time of the Terminal)
extern int    European_StartTradeMinute       = 0;     // minute, when will start a trading interval #2
extern int    European_FinishTradeHour        = 16;    // hour, when finishs a trading interval #2 (time of the Terminal)
extern int    European_FinishTradeMinute      = 0;     // minute, when finishs a trading interval #2
extern bool   TradeNewYorkMarket              = false; // enable/disable filter "trading interval of time #3"
extern int    NewYork_StartTradeHour          = 16;    // hour, when will start a trading interval #3 (time of the Terminal)
extern int    NewYork_StartTradeMinute        = 0;     // minute, when will start a trading interval #3
extern int    NewYork_FinishTradeHour         = 0;     // hour, when finishs a trading interval #3 (time of the Terminal)
extern int    NewYork_FinishTradeMinute       = 0;     // minute, when finishs a trading interval #3
   //---- others parameters -------------------------------------------------------------------+
extern string _____Others___________          = "---------------------------------------------";
extern int    Slippage                        = 2;     // maximum price slippage (in pips) at open and close orders
extern int    MagicNumber                     = 20110114; // "magic number" for orders of EA
extern color  ColorBuy                        = Blue;  // color arrows of Buy-orders
extern color  ColorSell                       = Red;   // color arrows of Sell-orders
extern bool   ShowInformation                 = true;  // enable/disable show on chart information
extern bool   SendEmail                       = false; // enable/disable send e-mail at open/close orders by EA
extern bool   SoundAlert                      = false; // enable/disable play sound-file at open/close orders by EA
extern string SoundFileAtOpen                 = "alert.wav";  // name of sound-file that will play at open order; empty string ("") = don't play sound-file at this is event
extern string SoundFileAtClose                = "alert2.wav"; // name of sound-file that will play at close order; empty string ("") = don't play sound-file at this is event
extern string SoundFileAtModify               = "";    // name of sound-file that will played at modify order; empty string ("") = don't play sound-file at this is event
extern bool   CreateScreenshots               = false; // enable/disable create screenshots at open, modify and close any order
extern bool   SaveOrdersHistory               = true;  // enable/disable write orders history to csv-file
extern bool   WriteLog                        = true;  // enable/disable write to log-files about errors and trades
extern bool   WriteDebugLog                   = false; // enable/disable write debug information to log-files (needs for detect errors in trade-logic, create a huge log-file)
extern bool   WriteToSeparateLogFile          = true;  // true = write log information to separate log-files; false = write log informations to public log-files

//----- internal parameters -------------------------------------------------------------------+
static double MoveToBE                        = 0;
static double MoveToBE_Offset                 = 0;
static double TrailingStop                    = 0;
static double TS_StartAfterProfit             = -1;
static double TS_Step                         = 1;
static double TS_CloseLotsPercent             = 0;

//----- global variables ----------------------------------------------------------------------+
static bool     first_run = true;
static bool     is_testing;
static bool     play_sound_at_open;
static bool     play_sound_at_close;
static bool     play_sound_at_modify;
static int      percent_digits = 2;
static int      pips_digits;
static int      digits;
static int      correction;
static int      slippage;
static int      lots_digits;
static int      period;
static int      fhandle_logs = -1;
static int      fhandle_ordershistory = -1;
static int      OpenedOrders[NumberTicketsInArray];
static int      OpenedOrders_Latency[NumberTicketsInArray];
static datetime bartime_newbar;
static datetime bartime_logs;
static datetime bartime;
static double   maxlots;
static double   minlots;
static double   lotstep;
static double   percent_freemargin;
static double   point;
static double   main_sl;
static double   main_tp;
static double   main_ts_distance;
static double   main_ts_profit;
static double   main_ts_step;
static double   main_be_profit;
static double   main_be_offset;
static string   symbol;
static string   account_currency;
static string   str_TradingTime;
static string   path_logs;
static string   path_screenshots;
static string   path_ordershistory;
static string   current_log_file_name;
static double   PALLine_HighThreshold;
static int      slow_trades_counter = 0;
static string   sc_label_objname;
static string   qt_label_objname;
static int      prev_orders_total_history;
static int      TR_num_orders_loss;
static int      TR_num_orders_profit;
static double   TR_gross_profit;
static datetime TR_TimeAtStartEA;
static double   TR_BalanceAtStartEA;
static string   gv_name_starttime;
static string   gv_name_startbalance;

//---------------------------------------------------------------------------------------------+
//---- init -----------------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int init()
  {
   is_testing = IsTesting();
   account_currency = AccountCurrency();
   symbol = Symbol();
   period = Period();
   //----
   if(WriteDebugLog) WriteLog = true;
   if(WriteLog)
     {
      if(WriteToSeparateLogFile)
        {
         path_logs = StringConcatenate(FolderName_Expert,"\\",StringSubstr(symbol,0,6),"\\",DoubleToStr(MagicNumber,0),"\\",FolderName_Logs,"\\");
         datetime cur_bartime_d1 = iTime(NULL,PERIOD_D1,0);
         if(is_testing) int mode = FILE_CSV|FILE_WRITE;
         else mode = FILE_CSV|FILE_READ|FILE_WRITE;
         current_log_file_name = StringConcatenate(path_logs,TimeToStr(cur_bartime_d1,TIME_DATE),".log");
         fhandle_logs = FileOpen(current_log_file_name,mode,CSVFile_Separator);
         if(fhandle_logs <= 0)
           {
            Print("WriteLog: Cannot open file ",current_log_file_name);
            return(0);
           }
         FileSeek(fhandle_logs,0,SEEK_END);
        }
      if(WriteDebugLog)
        {
         WriteFileLogs(fhandle_logs,"*************************** Initialization ***************************");
         WriteFileLogs(fhandle_logs,StringConcatenate("IsTesting = ",                  BoolToStr(is_testing)));
         WriteFileLogs(fhandle_logs,StringConcatenate("Symbol = \"",                   symbol,"\""));
         WriteFileLogs(fhandle_logs,StringConcatenate("Period = ",                     TimeFrameToStr(period)));
         WriteFileLogs(fhandle_logs,"Values of External Parameters:");
         WriteFileLogs(fhandle_logs,StringConcatenate("SlowCount = ",                  DoubleToStr(SlowCount,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("Latency = ",                    DoubleToStr(Latency,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("ResetSlowTrade = ",             BoolToStr(ResetSlowTrade)));
         WriteFileLogs(fhandle_logs,StringConcatenate("QuietTime = ",                  DoubleToStr(QuietTime,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("PALLine_LowThreshold = ",       DoubleToStr(PALLine_LowThreshold,8)));
         WriteFileLogs(fhandle_logs,StringConcatenate("StopMode_0_2 = ",               DoubleToStr(StopMode_0_2,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("StopLoss = ",                   DoubleToStr(StopLoss,8)));
         WriteFileLogs(fhandle_logs,StringConcatenate("TakeProfit = ",                 DoubleToStr(TakeProfit,8)));
         WriteFileLogs(fhandle_logs,StringConcatenate("TrailingStop_Distance = ",      DoubleToStr(TrailingStop_Distance,8)));
         WriteFileLogs(fhandle_logs,StringConcatenate("TrailingStop_CloseLotsPercent = ",DoubleToStr(TrailingStop_CloseLotsPercent,8)));
         WriteFileLogs(fhandle_logs,StringConcatenate("UseMM = ",                      BoolToStr(UseMM)));
         WriteFileLogs(fhandle_logs,StringConcatenate("Lots = ",                       DoubleToStr(Lots,8)));
         WriteFileLogs(fhandle_logs,StringConcatenate("LotsRiskReductor = ",           DoubleToStr(LotsRiskReductor,8)));
         WriteFileLogs(fhandle_logs,StringConcatenate("MaxLots = ",                    DoubleToStr(MaxLots,8)));
         WriteFileLogs(fhandle_logs,StringConcatenate("UseTradingHours = ",            BoolToStr(UseTradingHours)));
         WriteFileLogs(fhandle_logs,StringConcatenate("TradeAsianMarket = ",           BoolToStr(TradeAsianMarket)));
         WriteFileLogs(fhandle_logs,StringConcatenate("Asian_StartTradeHour = ",       DoubleToStr(Asian_StartTradeHour,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("Asian_StartTradeMinute = ",     DoubleToStr(Asian_StartTradeMinute,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("Asian_FinishTradeHour = ",      DoubleToStr(Asian_FinishTradeHour,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("Asian_FinishTradeMinute = ",    DoubleToStr(Asian_FinishTradeMinute,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("TradeEuropeanMarket = ",        BoolToStr(TradeEuropeanMarket)));
         WriteFileLogs(fhandle_logs,StringConcatenate("European_StartTradeHour = ",    DoubleToStr(European_StartTradeHour,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("European_StartTradeMinute = ",  DoubleToStr(European_StartTradeMinute,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("European_FinishTradeHour = ",   DoubleToStr(European_FinishTradeHour,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("European_FinishTradeMinute = ", DoubleToStr(European_FinishTradeMinute,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("TradeNewYorkMarket = ",         BoolToStr(TradeNewYorkMarket)));
         WriteFileLogs(fhandle_logs,StringConcatenate("NewYork_StartTradeHour = ",     DoubleToStr(NewYork_StartTradeHour,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("NewYork_StartTradeMinute = ",   DoubleToStr(NewYork_StartTradeMinute,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("NewYork_FinishTradeHour = ",    DoubleToStr(NewYork_FinishTradeHour,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("NewYork_FinishTradeMinute = ",  DoubleToStr(NewYork_FinishTradeMinute,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("Slippage = ",                   DoubleToStr(Slippage,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("MagicNumber = ",                DoubleToStr(MagicNumber,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("ColorBuy = ",                   DoubleToStr(ColorBuy,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("ColorSell = ",                  DoubleToStr(ColorSell,0)));
         WriteFileLogs(fhandle_logs,StringConcatenate("ShowInformation = ",            BoolToStr(ShowInformation)));
         WriteFileLogs(fhandle_logs,StringConcatenate("SendEmail = ",                  BoolToStr(SendEmail)));
         WriteFileLogs(fhandle_logs,StringConcatenate("SoundAlert = ",                 BoolToStr(SoundAlert)));
         WriteFileLogs(fhandle_logs,StringConcatenate("SoundFileAtOpen = \"",          SoundFileAtOpen,"\""));
         WriteFileLogs(fhandle_logs,StringConcatenate("SoundFileAtClose = \"",         SoundFileAtClose,"\""));
         WriteFileLogs(fhandle_logs,StringConcatenate("SoundFileAtModify = \"",        SoundFileAtModify,"\""));
         WriteFileLogs(fhandle_logs,StringConcatenate("CreateScreenshots = ",          BoolToStr(CreateScreenshots)));
         WriteFileLogs(fhandle_logs,StringConcatenate("SaveOrdersHistory = ",          BoolToStr(SaveOrdersHistory)));
         WriteFileLogs(fhandle_logs,StringConcatenate("WriteLog = ",                   BoolToStr(WriteLog)));
         WriteFileLogs(fhandle_logs,StringConcatenate("WriteDebugLog = ",              BoolToStr(WriteDebugLog)));
         WriteFileLogs(fhandle_logs,StringConcatenate("WriteToSeparateLogFile = ",     BoolToStr(WriteToSeparateLogFile)));
        }
      bartime_logs = cur_bartime_d1;
     }
   //---- 
   if(CreateScreenshots) path_screenshots = StringConcatenate(FolderName_Expert,"\\",StringSubstr(symbol,0,6),"\\",DoubleToStr(MagicNumber,0),"\\",FolderName_Screenshots,"\\");
   //---- 
   if(SaveOrdersHistory)
     {
      path_ordershistory = StringConcatenate(FolderName_Expert,"\\",StringSubstr(symbol,0,6),"\\",DoubleToStr(MagicNumber,0),"\\");
      if(is_testing) mode = FILE_CSV|FILE_WRITE;
      else mode = FILE_CSV|FILE_READ|FILE_WRITE;
      fhandle_ordershistory = FileOpen(StringConcatenate(path_ordershistory,FileName_OrdersHistory,".csv"),mode,CSVFile_Separator);
      if(fhandle_ordershistory <= 0)
        {
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("SaveOrdersHistory: Cannot open file ",path_ordershistory,FileName_OrdersHistory,".csv"));
         return(0);
        }
      if(FileSize(fhandle_ordershistory) > 0) FileSeek(fhandle_ordershistory,0,SEEK_END);
      else
        {
         int num_chars = FileWrite(fhandle_ordershistory,"Ticket","Open Time","Type","Lots","Symbol","Open Price","Stop Loss","Take Profit","Close Time","Close Price","Commission","Swap","Profit","Magic Number","Comment","DurationAtOpen");
         if(num_chars < 0) if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("SaveOrdersHistory: FileWrite(",fhandle_ordershistory,") error = ",ErrorDescription(GetLastError())));
        }
      for(int i=0; i<NumberTicketsInArray; i++) OpenedOrders[i] = -1;
     }
   //---- 
   play_sound_at_open   = SoundAlert && (StringLen(SoundFileAtOpen)   > 0);
   play_sound_at_close  = SoundAlert && (StringLen(SoundFileAtClose)  > 0);
   play_sound_at_modify = SoundAlert && (StringLen(SoundFileAtModify) > 0);
   //---- 
   maxlots = MarketInfo(symbol,MODE_MAXLOT);
   minlots = MarketInfo(symbol,MODE_MINLOT);
   lotstep = MarketInfo(symbol,MODE_LOTSTEP);
   if(lotstep == 0.01) lots_digits = 2;
   else if(lotstep == 0.1) lots_digits = 1;
        else if(lotstep == 1) lots_digits = 0;
             else if(lotstep == 0.001) lots_digits = 3;
                  else lots_digits = 4;
   if(Digits < 4)
     {
      point = 0.01;
      digits = 2;
     }
   else
     {
      point = 0.0001;
      digits = 4;
     }
   pips_digits = Digits - digits;
   correction = MathPow(10,pips_digits);
   slippage = Slippage * correction;
   double Leverage = AccountLeverage();
   percent_freemargin = NormalizeDouble(LotsRiskReductor * (100.0 / Leverage),2);
   Lots = NormalizeDouble(Lots,lots_digits);
   if(Lots < minlots)
     {
      Lots = minlots;
      if(WriteDebugLog) WriteFileLogs(fhandle_logs,"Lots: value was replaced by minlots");
     }
   else
     {
      if(Lots > maxlots)
        {
         Lots = maxlots;
         if(WriteDebugLog) WriteFileLogs(fhandle_logs,"Lots: value was replaced by maxlots");
        }
     }
   //---- 
   switch(StopMode_0_2)
     {
      case 1:
         MoveToBE     = 0;
         TrailingStop = TrailingStop_Distance;
         TS_CloseLotsPercent = 0;
         break;
      case 2:
         MoveToBE     = 0;
         TrailingStop = TrailingStop_Distance;
         TS_CloseLotsPercent = NormalizeDouble(TrailingStop_CloseLotsPercent,percent_digits);
         break;
      default:
         StopMode_0_2 = 0;
         MoveToBE     = 0;
         TrailingStop = 0;
         break;
     }
   if(TrailingStop < 0)
     {
      if(StopLoss >= 0) TrailingStop = StopLoss;
      else TrailingStop = 0;
     }
   if(TS_Step < 0) TS_Step = TrailingStop;
   if(TS_StartAfterProfit < 0) TS_StartAfterProfit = TrailingStop;
   if(MoveToBE < 0)
     {
      if(StopLoss >= 0) MoveToBE = StopLoss;
      else MoveToBE = 0;
     }
   main_sl          = NormalizeDouble((-1) * StopLoss * correction,pips_digits);
   main_tp          = NormalizeDouble(TakeProfit * correction,pips_digits);
   main_ts_distance = NormalizeDouble(TrailingStop * correction,pips_digits);
   main_ts_profit   = NormalizeDouble(TS_StartAfterProfit * correction,pips_digits);
   main_ts_step     = NormalizeDouble(TS_Step * correction,pips_digits);
   main_be_profit   = NormalizeDouble(MoveToBE * correction,pips_digits);
   main_be_offset   = NormalizeDouble(MoveToBE_Offset * correction,pips_digits);
   //---- 
   PALLine_HighThreshold = 0.0 - PALLine_LowThreshold;
   if(is_testing)
     {
      TR_TimeAtStartEA    = TimeCurrent();
      TR_BalanceAtStartEA = AccountBalance();
     }
   else
     {
      gv_name_starttime    = StringConcatenate(ExpertName," StartTime",StringSubstr(symbol,0,6),DoubleToStr(MagicNumber,0));
      gv_name_startbalance = StringConcatenate(ExpertName," StartBalance",StringSubstr(symbol,0,6),DoubleToStr(MagicNumber,0));
      if(GlobalVariableCheck(gv_name_starttime) && GlobalVariableCheck(gv_name_startbalance))
        {
         TR_TimeAtStartEA    = GlobalVariableGet(gv_name_starttime);
         TR_BalanceAtStartEA = GlobalVariableGet(gv_name_startbalance);
         if(TR_TimeAtStartEA == 0 || TR_BalanceAtStartEA == 0)
           {
            TR_TimeAtStartEA    = TimeCurrent();
            TR_BalanceAtStartEA = AccountBalance();
            GlobalVariableSet(gv_name_starttime,   TR_TimeAtStartEA);
            GlobalVariableSet(gv_name_startbalance,TR_BalanceAtStartEA);
           }
        }
      else
        {
         TR_TimeAtStartEA    = TimeCurrent();
         TR_BalanceAtStartEA = AccountBalance();
         GlobalVariableSet(gv_name_starttime,   TR_TimeAtStartEA);
         GlobalVariableSet(gv_name_startbalance,TR_BalanceAtStartEA);
        }
     }
   prev_orders_total_history = -1;
   TR_num_orders_loss   = 0;
   TR_num_orders_profit = 0;
   TR_gross_profit      = 0.0;
   qt_label_objname = StringConcatenate(ExpertName," qt_label");
   sc_label_objname = StringConcatenate(ExpertName," sc_label");
   if(ResetSlowTrade)
     {
      slow_trades_counter = 0;
      ResetSlowTrade = false;
     }
   //---- 
   if(WriteDebugLog)
     {
      WriteFileLogs(fhandle_logs,StringConcatenate("TR_TimeAtStartEA = ",TimeToStr(TR_TimeAtStartEA,TIME_DATE|TIME_MINUTES|TIME_SECONDS)));
      WriteFileLogs(fhandle_logs,StringConcatenate("TR_BalanceAtStartEA = ",DoubleToStr(TR_BalanceAtStartEA,2)));
     }
   if(first_run)
     {
      bartime_newbar = Time[0];
      bartime = Time[0];
      first_run = false;
     }
   return(0);
  }

//---------------------------------------------------------------------------------------------+
//---- deinit ---------------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int deinit()
  {
   if(WriteLog)
     {
      WriteFileLogs(fhandle_logs,"************************** Deinitialization **************************");
      WriteFileLogs(fhandle_logs,StringConcatenate("Uninitialize Reason = ",GetUninitializeReason()));
     }
   if(SaveOrdersHistory) 
     {
      if(fhandle_ordershistory > 0)
        {
         FileClose(fhandle_ordershistory);
         fhandle_ordershistory = -1;
        }
     }
   if(WriteLog)
     {
      if(fhandle_logs > 0)
        {
         FileClose(fhandle_logs);
         fhandle_logs = -1;
        }
     }
   if(ObjectFind(sc_label_objname) >= 0) ObjectDelete(sc_label_objname);
   if(ObjectFind(qt_label_objname) >= 0) ObjectDelete(qt_label_objname);
   if(ShowInformation) Comment("");
   if(WriteLog) Print("----------------------- Deinitialization finished -----------------------");
   return(0);
  }

//---------------------------------------------------------------------------------------------+
//---- start ----------------------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
int start()
  {
   //----  - -----------------------------------------------------------------+
   if(WriteLog)
     {
      if(WriteToSeparateLogFile)
        {
         datetime cur_bartime_d1 = iTime(NULL,PERIOD_D1,0);
         if(bartime_logs != cur_bartime_d1)
           {
            if(fhandle_logs > 0)
              {
               FileFlush(fhandle_logs);
               int file_size = FileSize(fhandle_logs);
               FileClose(fhandle_logs);
               if(file_size == 0) FileDelete(current_log_file_name);
              }
            if(is_testing) int mode = FILE_CSV|FILE_WRITE;
            else mode = FILE_CSV|FILE_READ|FILE_WRITE;
            current_log_file_name = StringConcatenate(path_logs,TimeToStr(cur_bartime_d1,TIME_DATE),".log");
            fhandle_logs = FileOpen(current_log_file_name,mode,CSVFile_Separator);
            if(fhandle_logs <= 0)
              {
               Print(StringConcatenate("WriteLog: Cannot open file \"",current_log_file_name,"\""));
               return(0);
              }
            FileSeek(fhandle_logs,0,SEEK_END);
            bartime_logs = cur_bartime_d1;
           }
        }
     }
   //----     " "  " " ----------------------------------------+
   datetime cur_bartime = Time[0];
   if(WriteDebugLog)
     {
      if(bartime_newbar != cur_bartime)
        {
         WriteFileLogs(fhandle_logs,StringConcatenate("-------- New Bar at ",TimeToStr(cur_bartime,TIME_DATE|TIME_MINUTES|TIME_SECONDS)," ------------------------------"));
         bartime_newbar = cur_bartime;
        }
      WriteFileLogs(fhandle_logs,StringConcatenate("-------- New Tick at ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS)," ------------------------------"));
     }
   //----     -----------------------------------------------------+
   if(SaveOrdersHistory) WatchSaveOrdersHistoryMC(MagicNumber,symbol);
   //----    ------------------------------------------------------------------+
   if(TrailingStop > 0) WatchTrailingStopMC(main_ts_distance,main_ts_profit,main_ts_step,TS_CloseLotsPercent,MagicNumber,symbol);
   if(MoveToBE > 0) WatchMoveSLToBEMC(main_be_profit,main_be_offset,MagicNumber,symbol);
   SetOrderLevelsMC(main_tp,main_sl,MagicNumber,symbol);
   WatchOrderLevelsMC(main_tp,main_sl,MagicNumber,symbol);
   //----    (   ) --------------------------+
   CalculateTradeResultsMC(MagicNumber,symbol);
   //----      -------------------------------------------------+
   datetime cur_time = TimeCurrent();
   if(UseTradingHours)
     {
      bool is_trading_time = false;
      if(TradeAsianMarket) is_trading_time = IsTradeTime(cur_time,Asian_StartTradeHour,Asian_StartTradeMinute,Asian_FinishTradeHour,Asian_FinishTradeMinute);
      if(!is_trading_time)
        {
         if(TradeEuropeanMarket) is_trading_time = IsTradeTime(cur_time,European_StartTradeHour,European_StartTradeMinute,European_FinishTradeHour,European_FinishTradeMinute);
         if(!is_trading_time) if(TradeNewYorkMarket) is_trading_time = IsTradeTime(cur_time,NewYork_StartTradeHour,NewYork_StartTradeMinute,NewYork_FinishTradeHour,NewYork_FinishTradeMinute);
        }
     }
   else is_trading_time = true;
   if(!is_trading_time) str_TradingTime = "Now is not trading time";
   else str_TradingTime = "Now is trading time";
   //----    ----------------------------------------------------------+
   double PALLine = NormalizeDouble((High[0] + Low[0] - High[1] - Low[1]) / point,pips_digits);
   int trade_signal = 0;
   if(PALLine < PALLine_LowThreshold) trade_signal++;
   else if(PALLine > PALLine_HighThreshold) trade_signal--;
   //----   -------------------------------------------------------------+
   if(ShowInformation)
     {
      Comment(StringConcatenate(str_TradingTime,"\n",
                                "PALLine = ",DoubleToStr(PALLine,pips_digits),"\n",
                                "Trade Signal = ",TrendToStr(trade_signal),"\n",
                                "-----------------\n",
                                "StartTime = ",TimeToStr(TR_TimeAtStartEA,TIME_DATE|TIME_MINUTES),"\n",
                                "Profit = ",DoubleToStr(TR_gross_profit,2)," ",account_currency,"\n",
                                "BarsTraded = ",DoubleToStr(iBarShift(NULL,0,TR_TimeAtStartEA),0),"\n",
                                "ProfitCount = ",DoubleToStr(TR_num_orders_profit,0),"\n",
                                "LossCount = ",DoubleToStr(TR_num_orders_loss,0),"\n",
                                "StartBalance = ",DoubleToStr(TR_BalanceAtStartEA,2)," ",account_currency,"\n",
                                "CurrentBalance = ",DoubleToStr(AccountBalance(),2)," ",account_currency,"\n"
                               )
             );
     }
   //----    --------------------------------------------------------+
   if(WriteDebugLog)
     {
      WriteFileLogs(fhandle_logs,StringConcatenate("UseTradingHours: ",str_TradingTime));
      WriteFileLogs(fhandle_logs,StringConcatenate("PALLine = ",DoubleToStr(PALLine,pips_digits)));
      WriteFileLogs(fhandle_logs,StringConcatenate("Trade Signal = ",TrendToStr(trade_signal)));
      WriteFileLogs(fhandle_logs,StringConcatenate("slow_trades_counter = ",DoubleToStr(slow_trades_counter,0)));
     }
   //----    ""   --------------------------+
   if(slow_trades_counter >= SlowCount)
     {
      CreateObjectLabel(sc_label_objname,SC_Label_Corner,SC_Label_OffsetX,SC_Label_OffsetY,SC_Label_FontSize,SC_Label_Color,SC_Label_FontName,0,SC_Label_Text);
      return(0);
     }
   else if(ObjectFind(sc_label_objname) >= 0) ObjectDelete(sc_label_objname);
   //----  "    " -------------------------------+
   bool first_trade_after_qt = false;
   if(QuietTime > 0)
     {
      int num_bars = NumBarsAfterLastLoss(-1,MagicNumber,symbol);
      if(WriteDebugLog) WriteFileLogs(fhandle_logs,StringConcatenate("num_bars = ",DoubleToStr(num_bars,0)));
      if(num_bars < 0)
        {
         if(ObjectFind(qt_label_objname) >= 0) ObjectDelete(qt_label_objname);
        }
      else
        {
         if(num_bars < QuietTime)
           {
            string obj_text = StringConcatenate(QT_Label_Text_1,DoubleToStr(QuietTime - num_bars,0),QT_Label_Text_2);
            CreateObjectLabel(qt_label_objname,QT_Label_Corner,QT_Label_OffsetX,QT_Label_OffsetY,QT_Label_FontSize,QT_Label_Color,QT_Label_FontName,0,obj_text);
            return(0);
           }
         else
           {
            if(ObjectFind(qt_label_objname) >= 0) ObjectDelete(qt_label_objname);
            first_trade_after_qt = true;
           }
        }
     }
   //----         ,   -------------------------+
   if(trade_signal == 0) return(0);
   if(!is_trading_time)  return(0);
   //----     Buy -----------------------------------------------------+
   if(trade_signal > 0)
     {
      if(WriteDebugLog) WriteFileLogs(fhandle_logs,"Have a signal for open BUY.");
      //----      ->  ------------------------------------+
      int num_pos = HavePositionsMC(OP_BUY,MagicNumber,symbol);
      if(WriteDebugLog) WriteFileLogs(fhandle_logs,StringConcatenate("num_pos = ",DoubleToStr(num_pos,0)));
      if(num_pos != 0) return(0);
      //----    -------------------------------------------------------+
      num_pos = ClosePositionsMC(OP_SELL,MagicNumber,symbol);
      if(num_pos < 0)
        {
         bartime--;
         return(0);
        }
      //----  Buy- ----------------------------------------------------------------+
      if(num_pos != 0 || !first_trade_after_qt) string first_trade = "";
      else first_trade = "_1";
      string expert_comment = StringConcatenate(ExpertComment,"_",DoubleToStr(/*PALLine*/PALLine_LowThreshold,1),"_",DoubleToStr(NumBarsAfterLastOrder(MagicNumber,symbol),0),"_",DoubleToStr(StopMode_0_2,0),first_trade);
      if(OpenOrderMC(OP_BUY,MagicNumber,expert_comment,LotsOptimized(OP_BUY,symbol)) < 0) bartime--;
     }
   //----     Sell ----------------------------------------------------+
   else
     {
      if(WriteDebugLog) WriteFileLogs(fhandle_logs,"Have a signal for open SELL.");
      //----      ->  -----------------------------------+
      num_pos = HavePositionsMC(OP_SELL,MagicNumber,symbol);
      if(WriteDebugLog) WriteFileLogs(fhandle_logs,StringConcatenate("num_pos = ",DoubleToStr(num_pos,0)));
      if(num_pos != 0) return(0);
      //----    --------------------------------------------------------+
      num_pos = ClosePositionsMC(OP_BUY,MagicNumber,symbol);
      if(num_pos < 0)
        {
         bartime--;
         return(0);
        }
      //----  Sell- ---------------------------------------------------------------+
      if(num_pos != 0 || !first_trade_after_qt) first_trade = "";
      else first_trade = "_1";
      expert_comment = StringConcatenate(ExpertComment,"_",DoubleToStr(/*PALLine*/PALLine_HighThreshold,1),"_",DoubleToStr(NumBarsAfterLastOrder(MagicNumber,symbol),0),"_",DoubleToStr(StopMode_0_2,0),first_trade);
      if(OpenOrderMC(OP_SELL,MagicNumber,expert_comment,LotsOptimized(OP_SELL,symbol)) < 0) bartime--;
     }
   //----    ----------------------------------------------------------------+
   return(0);
   Print("---- Programming by Serega Lykov, http://mtexperts.narod.ru/ ----");
  }

//---------------------------------------------------------------------------------------------+
//---- ErrorDescription -----------------------------------------------------------------------+
//---------------------------------------------------------------------------------------------+
string ErrorDescription(int error_code)
  {
   switch(error_code)
     {
      case 0:
      case 1:    string error_string="no error";                                          break;
      case 2:    error_string="common error";                                             break;
      case 3:    error_string="invalid trade parameters";                                 break;
      case 4:    error_string="trade server is busy";                                     break;
      case 5:    error_string="old version of the client terminal";                       break;
      case 6:    error_string="no connection with trade server";                          break;
      case 7:    error_string="not enough rights";                                        break;
      case 8:    error_string="too frequent requests";                                    break;
      case 9:    error_string="malfunctional trade operation (never returned error)";     break;
      case 64:   error_string="account disabled";                                         break;
      case 65:   error_string="invalid account";                                          break;
      case 128:  error_string="trade timeout";                                            break;
      case 129:  error_string="invalid price";                                            break;
      case 130:  error_string="invalid stops";                                            break;
      case 131:  error_string="invalid trade volume";                                     break;
      case 132:  error_string="market is closed";                                         break;
      case 133:  error_string="trade is disabled";                                        break;
      case 134:  error_string="not enough money";                                         break;
      case 135:  error_string="price changed";                                            break;
      case 136:  error_string="off quotes";                                               break;
      case 137:  error_string="broker is busy (never returned error)";                    break;
      case 138:  error_string="requote";                                                  break;
      case 139:  error_string="order is locked";                                          break;
      case 140:  error_string="long positions only allowed";                              break;
      case 141:  error_string="too many requests";                                        break;
      case 145:  error_string="modification denied because order too close to market";    break;
      case 146:  error_string="trade context is busy";                                    break;
      case 147:  error_string="expirations are denied by broker";                         break;
      case 148:  error_string="amount of open and pending orders has reached the limit";  break;
      case 149:  error_string="hedging is prohibited";                                    break;
      case 150:  error_string="prohibited by FIFO rules";                                 break;
      case 4000: error_string="no error (never generated code)";                          break;
      case 4001: error_string="wrong function pointer";                                   break;
      case 4002: error_string="array index is out of range";                              break;
      case 4003: error_string="no memory for function call stack";                        break;
      case 4004: error_string="recursive stack overflow";                                 break;
      case 4005: error_string="not enough stack for parameter";                           break;
      case 4006: error_string="no memory for parameter string";                           break;
      case 4007: error_string="no memory for temp string";                                break;
      case 4008: error_string="not initialized string";                                   break;
      case 4009: error_string="not initialized string in array";                          break;
      case 4010: error_string="no memory for array\' string";                             break;
      case 4011: error_string="too long string";                                          break;
      case 4012: error_string="remainder from zero divide";                               break;
      case 4013: error_string="zero divide";                                              break;
      case 4014: error_string="unknown command";                                          break;
      case 4015: error_string="wrong jump (never generated error)";                       break;
      case 4016: error_string="not initialized array";                                    break;
      case 4017: error_string="dll calls are not allowed";                                break;
      case 4018: error_string="cannot load library";                                      break;
      case 4019: error_string="cannot call function";                                     break;
      case 4020: error_string="expert function calls are not allowed";                    break;
      case 4021: error_string="not enough memory for temp string returned from function"; break;
      case 4022: error_string="system is busy (never generated error)";                   break;
      case 4050: error_string="invalid function parameters count";                        break;
      case 4051: error_string="invalid function parameter value";                         break;
      case 4052: error_string="string function internal error";                           break;
      case 4053: error_string="some array error";                                         break;
      case 4054: error_string="incorrect series array using";                             break;
      case 4055: error_string="custom indicator error";                                   break;
      case 4056: error_string="arrays are incompatible";                                  break;
      case 4057: error_string="global variables processing error";                        break;
      case 4058: error_string="global variable not found";                                break;
      case 4059: error_string="function is not allowed in testing mode";                  break;
      case 4060: error_string="function is not confirmed";                                break;
      case 4061: error_string="send mail error";                                          break;
      case 4062: error_string="string parameter expected";                                break;
      case 4063: error_string="integer parameter expected";                               break;
      case 4064: error_string="double parameter expected";                                break;
      case 4065: error_string="array as parameter expected";                              break;
      case 4066: error_string="requested history data in update state";                   break;
      case 4099: error_string="end of file";                                              break;
      case 4100: error_string="some file error";                                          break;
      case 4101: error_string="wrong file name";                                          break;
      case 4102: error_string="too many opened files";                                    break;
      case 4103: error_string="cannot open file";                                         break;
      case 4104: error_string="incompatible access to a file";                            break;
      case 4105: error_string="no order selected";                                        break;
      case 4106: error_string="unknown symbol";                                           break;
      case 4107: error_string="invalid price parameter for trade function";               break;
      case 4108: error_string="invalid ticket";                                           break;
      case 4109: error_string="trade is not allowed in the expert properties";            break;
      case 4110: error_string="longs are not allowed in the expert properties";           break;
      case 4111: error_string="shorts are not allowed in the expert properties";          break;
      case 4200: error_string="object is already exist";                                  break;
      case 4201: error_string="unknown object property";                                  break;
      case 4202: error_string="object is not exist";                                      break;
      case 4203: error_string="unknown object type";                                      break;
      case 4204: error_string="no object name";                                           break;
      case 4205: error_string="object coordinates error";                                 break;
      case 4206: error_string="no specified subwindow";                                   break;
      default:   error_string="unknown error";
     }
   return(error_string);
  }

//---------------------------------------------------------------------------------------------+
//---- GetUninitializeReason ------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
string GetUninitializeReason()
  {
   switch(UninitializeReason())
     {
      case 0:           string reason = "Script finished its execution independently."; break;
      case REASON_REMOVE:      reason = "Programm removed from chart.";                 break;
      case REASON_RECOMPILE:   reason = "Programm recompiled.";                         break;
      case REASON_CHARTCHANGE: reason = "Symbol or timeframe changed on the chart.";    break;
      case REASON_CHARTCLOSE:  reason = "Chart closed.";                                break;
      case REASON_PARAMETERS:  reason = "Inputs parameters was changed by user.";       break;
      case REASON_ACCOUNT:     reason = "Other account activated.";                     break;
      default:                 reason = "Unknown.";                                     break;
     }
   return(reason);
  }
  
//---------------------------------------------------------------------------------------------+
//---- BoolToStr ------------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
string BoolToStr(bool bool_value)
  {
   if(!bool_value) return("false");
   return("true");
  }

//---------------------------------------------------------------------------------------------+
//---- TimeFrameToStr -------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
string TimeFrameToStr(int period)
  {
   switch(period)
     {
      case     1: string TimeFrameStr = "M1";          break;
      case     5:        TimeFrameStr = "M5";          break;
      case    15:        TimeFrameStr = "M15";         break;
      case    30:        TimeFrameStr = "M30";         break;
      case    60:        TimeFrameStr = "H1";          break;
      case   240:        TimeFrameStr = "H4";          break;
      case  1440:        TimeFrameStr = "D1";          break;
      case 10080:        TimeFrameStr = "W1";          break;
      case 43200:        TimeFrameStr = "MN";          break;
      default:           TimeFrameStr = TimeFrameToStr(Period());
     }
   return(TimeFrameStr);
  }

//---------------------------------------------------------------------------------------------+
//---- TrendToStr -----------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
string TrendToStr(int trend)
  {
   if(trend > 0) return("Buy");
   if(trend < 0) return("Sell");
   return("None");
  }

//---------------------------------------------------------------------------------------------+
//---- OrderTypeToStr -------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
string OrderTypeToStr(int order_type)
  {
   switch(order_type)
     {
      case OP_BUY: string result = "Buy";       break;
      case OP_SELL:       result = "Sell";      break;
      case OP_BUYLIMIT:   result = "BuyLimit";  break;
      case OP_SELLLIMIT:  result = "SellLimit"; break;
      case OP_BUYSTOP:    result = "BuyStop";   break;
      case OP_SELLSTOP:   result = "SellStop";  break;
      default:            result = "Unknown";   break;
     }
   return(result);
  }

//---------------------------------------------------------------------------------------------+
//---- CreateObjectLabel ----------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
void CreateObjectLabel(string obj_name, int corner, int offset_x, int offset_y, int fontsize, color obj_color, string fontname, int obj_window = 0, string obj_text = "")
  {
   if(ObjectFind(obj_name) < 0) ObjectCreate(obj_name,OBJ_LABEL,obj_window,0,0);
   ObjectSet(obj_name,OBJPROP_CORNER,corner);
   ObjectSet(obj_name,OBJPROP_XDISTANCE,offset_x);
   ObjectSet(obj_name,OBJPROP_YDISTANCE,offset_y);
   ObjectSetText(obj_name,obj_text,fontsize,fontname,obj_color);
  }

//---------------------------------------------------------------------------------------------+
//---- CreateScreenshot -----------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
bool CreateScreenshot()
  {
   RefreshRates();
   datetime cur_time = TimeCurrent();
   string file_name = StringConcatenate(path_screenshots,"Screenshot_",IntegerToStr(TimeYear(cur_time),4),"_",IntegerToStr(TimeMonth(cur_time),2),"_",IntegerToStr(TimeDay(cur_time),2)," ",IntegerToStr(TimeHour(cur_time),2),"_",IntegerToStr(TimeMinute(cur_time),2),"_",IntegerToStr(TimeSeconds(cur_time),2),".gif");
   bool error = WindowScreenShot(file_name,ScreenshotSizeX,ScreenshotSizeY,ScreenshotStartBar,ScreenshotChartScale,ScreenshotChartMode);
   if(!error)
     {
      if(WriteDebugLog) WriteFileLogs(fhandle_logs,StringConcatenate("CreateScreenshot: WindowScreenShot() error = ",ErrorDescription(GetLastError())));
     }
   return(error);
  }

//---------------------------------------------------------------------------------------------+
//---- IntegerToStr ---------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
string IntegerToStr(int integer_number, int minimum_chars, string add_char = "0")
  {
   string result = DoubleToStr(integer_number,0);
   for(int i=minimum_chars-StringLen(result); i>0; i--) result = StringConcatenate(add_char,result);
   return(result);
  }

//---------------------------------------------------------------------------------------------+
//---- WriteFileLogs --------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
bool WriteFileLogs(int fhandle, string message)
  {
   RefreshRates();
   if(fhandle >= 0)
     {
      int num_chars = FileWrite(fhandle,StringConcatenate(TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS)," : ",message)); 
      if(num_chars < 0)
        {
         Print("WriteFileLogs: FileWrite(",fhandle,") error = ",ErrorDescription(GetLastError()));
         Print("WriteFileLogs: ",StringConcatenate(TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS)," : ",message));
         return(false);
        }
     }
   else Print(message);
   return(true);
  }

//---------------------------------------------------------------------------------------------+
//---- IsTradeTime ----------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
bool IsTradeTime(datetime c_time, int start_hour, int start_minute, int finish_hour, int finish_minute)
  {
   int cur_hour = TimeHour(c_time);
   int cur_min = TimeMinute(c_time);
   if(start_hour == finish_hour && start_minute == finish_minute) return(true);
   if(finish_minute == 0)
     {
      if(finish_hour == 0) int fth = 23;
      else fth = finish_hour - 1;
      int ftm = 59;      
     }
   else
     {
      fth = finish_hour;
      ftm = finish_minute - 1;      
     }
   if(start_hour == fth)
     {
      if(start_minute == ftm) return(true);
      if(start_minute < ftm)
        {
         if(cur_hour != start_hour) return(false);
         if(cur_min < start_minute || cur_min > ftm) return(false);
         return(true);
        }
      if(start_minute > ftm)
        {
         if(cur_hour == start_hour)
           {
            if(cur_min < start_minute && cur_min > ftm) return(false);
           }
         return(true);
        }
     }
   if(start_hour < fth)
     {
      if(cur_hour < start_hour || cur_hour > fth) return(false);
      if(cur_hour == start_hour && cur_min < start_minute) return(false);
      if(cur_hour == fth && cur_min > ftm) return(false);
      return(true);
     }
   if(start_hour > fth)
     {
      if(cur_hour < start_hour && cur_hour > fth) return(false);
      if(cur_hour == start_hour && cur_min < start_minute) return(false);
      if(cur_hour == fth && cur_min > ftm) return(false);
      return(true);
     }
   return(true);
  }

//---------------------------------------------------------------------------------------------+
//---- WatchTrailingStopMC --------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
void WatchTrailingStopMC(double ts_distance, double ts_profit, double ts_step, double ts_close_percent, int magic_number, string ts_symbol = "")
  {
   if(StringLen(ts_symbol) <= 0) bool check_order_symbol = false;
   else check_order_symbol = true;
   RefreshRates();
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("WatchTrailingStopMC: OrderSelect() error = ",ErrorDescription(GetLastError())));
         continue;
        }
      if(magic_number >= 0) if(OrderMagicNumber() != magic_number) continue;
      string order_symbol = OrderSymbol();
      if(check_order_symbol) if(order_symbol != ts_symbol) continue;
      int order_digits = MarketInfo(order_symbol,MODE_DIGITS);
      double order_point = MarketInfo(order_symbol,MODE_POINT);
      double stoplevel = NormalizeDouble(MarketInfo(order_symbol,MODE_STOPLEVEL) * order_point,order_digits);
      double buy_new_stoploss  = NormalizeDouble(MarketInfo(order_symbol,MODE_BID) - ts_distance*order_point,order_digits);
      double sell_new_stoploss = NormalizeDouble(MarketInfo(order_symbol,MODE_ASK) + ts_distance*order_point,order_digits);
      int order_type = OrderType();
      int order_ticket = OrderTicket();
      double order_lots = NormalizeDouble(OrderLots(),lots_digits);
      double order_open_price  = NormalizeDouble(OrderOpenPrice(), order_digits);
      double order_close_price = NormalizeDouble(OrderClosePrice(),order_digits);
      double order_take_profit = NormalizeDouble(OrderTakeProfit(),order_digits);
      double order_stop_loss   = NormalizeDouble(OrderStopLoss(),  order_digits);
      if(order_type == OP_BUY)
        {
         if(NormalizeDouble(order_close_price - order_open_price,order_digits) < NormalizeDouble(ts_profit*order_point,order_digits)) continue;
         if(order_close_price <= buy_new_stoploss)
           {
            if(WriteDebugLog) WriteFileLogs(fhandle_logs,"WatchTrailingStopMC: closing by stealth trailing stop.");
            OrderCloseEx(order_ticket,OrderLots(),order_close_price,slippage,ColorBuy,"WatchTrailingStopMC");
           }
         else
           {
            if(order_stop_loss < buy_new_stoploss)
              {
               if(NormalizeDouble(buy_new_stoploss - order_stop_loss,order_digits) >= NormalizeDouble(ts_step*order_point,order_digits))
                 {
                  if(NormalizeDouble(order_close_price - buy_new_stoploss,order_digits) > stoplevel)
                    {
                     if(WriteDebugLog) WriteFileLogs(fhandle_logs,StringConcatenate("WatchTrailingStopMC: order_ticket = ",DoubleToStr(order_ticket,0),",  buy_new_stoploss = ",DoubleToStr(buy_new_stoploss,8)));
                     OrderModifyEx(order_ticket,order_open_price,buy_new_stoploss,order_take_profit,0,ColorBuy,"WatchTrailingStopMC");
                    }
                  else if(WriteDebugLog) WriteFileLogs(fhandle_logs,StringConcatenate("WatchTrailingStopMC: ticket ",DoubleToStr(order_ticket,0)," = it is impossible to move, the level stop-loss is near to the close price."));
                 }
              }
            if(ts_close_percent > 0)
              {
               if(ts_close_percent < 100.0)
                 {
                  double closed_lots  = NormalizeDouble(GetClosedLotsMC(order_ticket,OrderOpenTime(),order_type,magic_number,ts_symbol),lots_digits);
                  double initial_lots = NormalizeDouble(order_lots + closed_lots,lots_digits);
                  double lots_for_close = NormalizeDouble(initial_lots * ts_close_percent / 100.0,lots_digits);
                  order_lots = NormalizeDouble(lots_for_close - closed_lots,lots_digits);
                 }
               if(order_lots > 0) OrderCloseEx(order_ticket,order_lots,order_close_price,slippage,ColorBuy,"WatchTrailingStopMC(2)");
              }
           }
        }
      else
        {
         if(NormalizeDouble(order_open_price - order_close_price,order_digits) < NormalizeDouble(ts_profit*order_point,order_digits)) continue;
         if(order_close_price >= sell_new_stoploss)
           {
            if(WriteDebugLog) WriteFileLogs(fhandle_logs,"WatchTrailingStopMC: closing by stealth trailing stop.");
            OrderCloseEx(order_ticket,OrderLots(),order_close_price,slippage,ColorSell,"WatchTrailingStopMC");
           }
         else
           {
            if(order_stop_loss == 0 || order_stop_loss > sell_new_stoploss)
              {
               if(order_stop_loss == 0 || NormalizeDouble(order_stop_loss - sell_new_stoploss,order_digits) > NormalizeDouble(ts_step*order_point,order_digits))
                 {
                  if(NormalizeDouble(sell_new_stoploss - order_close_price,order_digits) > stoplevel)
                    {
                     if(WriteDebugLog) WriteFileLogs(fhandle_logs,StringConcatenate("WatchTrailingStopMC: order_ticket = ",DoubleToStr(order_ticket,0),",  sell_new_stoploss = ",DoubleToStr(sell_new_stoploss,8)));
                     OrderModifyEx(order_ticket,order_open_price,sell_new_stoploss,order_take_profit,0,ColorSell,"WatchTrailingStopMC");
                    }
                  else if(WriteDebugLog) WriteFileLogs(fhandle_logs,StringConcatenate("WatchTrailingStopMC: ticket ",DoubleToStr(order_ticket,0)," = it is impossible to move, the level stop-loss is near to the close price."));
                 }
              }
            if(ts_close_percent > 0)
              {
               if(ts_close_percent < 100.0)
                 {
                  closed_lots  = NormalizeDouble(GetClosedLotsMC(order_ticket,OrderOpenTime(),order_type,magic_number,ts_symbol),lots_digits);
                  initial_lots = NormalizeDouble(order_lots + closed_lots,lots_digits);
                  lots_for_close = NormalizeDouble(initial_lots * ts_close_percent / 100.0,lots_digits);
                  order_lots = NormalizeDouble(lots_for_close - closed_lots,lots_digits);
                 }
               if(order_lots > 0) OrderCloseEx(order_ticket,order_lots,order_close_price,slippage,ColorSell,"WatchTrailingStopMC(2)");
              }
           }
        }
     }
  }

//---------------------------------------------------------------------------------------------+
//---- GetClosedLotsMC ------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
double GetClosedLotsMC(int order_ticket, datetime order_open_time, int order_type, int magic_number, string gcl_symbol = "")
  {
   if(StringLen(gcl_symbol) <= 0) bool check_order_symbol = false;
   else check_order_symbol = true;
   double closed_lots = 0;
   int total = OrdersHistoryTotal();
   if(total == 0) return(closed_lots);
   total--;
   if(!is_testing)
     {
      string to_find = StringConcatenate("to #",DoubleToStr(order_ticket,0));
      for(int i=total; i>=0; i--)
        {
         if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
           {
            if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("GetClosedLotsMC: OrderSelect() error = ",ErrorDescription(GetLastError())));
            continue;
           }
         if(OrderMagicNumber() != magic_number) continue;
         if(OrderType() != order_type) continue;
         if(check_order_symbol) if(OrderSymbol() != gcl_symbol) continue;
         if(OrderComment() != to_find) continue;
         closed_lots = NormalizeDouble(closed_lots + OrderLots() + GetClosedLotsMC(OrderTicket(),order_open_time,order_type,magic_number,gcl_symbol),lots_digits);
         break;
        }
     }
   else
     {
      for(i=total; i>=0; i--)
        {
         if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
           {
            if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("GetClosedLotsMC: OrderSelect() error = ",ErrorDescription(GetLastError())));
            continue;
           }
         if(OrderMagicNumber() != magic_number) continue;
         if(OrderType() != order_type) continue;
         if(OrderOpenTime() < order_open_time) continue;
         if(check_order_symbol) if(OrderSymbol() != gcl_symbol) continue;
         closed_lots = NormalizeDouble(closed_lots + OrderLots(),lots_digits);
        }
     }
   return(closed_lots);
  }

//---------------------------------------------------------------------------------------------+
//---- WatchMoveSLToBEMC ----------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
void WatchMoveSLToBEMC(double be_profit, double be_offset, int magic_number, string be_symbol = "")
  {
   if(StringLen(be_symbol) <= 0) bool check_order_symbol = false;
   else check_order_symbol = true;
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("WatchMoveSLToBEMC: OrderSelect() error = ",ErrorDescription(GetLastError())));
         continue;
        }
      if(magic_number >= 0) if(OrderMagicNumber() != magic_number) continue;
      string order_symbol = OrderSymbol();
      if(check_order_symbol) if(order_symbol != be_symbol) continue;
      int order_digits = MarketInfo(order_symbol,MODE_DIGITS);
      double order_point = MarketInfo(order_symbol,MODE_POINT);
      double stoplevel = NormalizeDouble(MarketInfo(order_symbol,MODE_STOPLEVEL) * order_point,order_digits);
      int order_type = OrderType();
      int order_ticket = OrderTicket();
      double order_open_price  = NormalizeDouble(OrderOpenPrice(), order_digits);
      double order_stop_loss   = NormalizeDouble(OrderStopLoss(),  order_digits);
      double order_close_price = NormalizeDouble(OrderClosePrice(),order_digits);
      double order_take_profit = NormalizeDouble(OrderTakeProfit(),order_digits);
      if(order_type == OP_BUY)
        {
         double new_stop_loss = NormalizeDouble(order_open_price + be_offset*order_point,order_digits);
         if(order_stop_loss >= new_stop_loss) continue;
         double order_profit = NormalizeDouble(order_close_price - order_open_price,order_digits);
         color ColorMove = ColorBuy;
        }
      else
        {
         new_stop_loss = NormalizeDouble(order_open_price - be_offset*order_point,order_digits);
         if(order_stop_loss != 0 && order_stop_loss <= new_stop_loss) continue;
         order_profit = NormalizeDouble(order_open_price - order_close_price,order_digits);
         ColorMove = ColorSell;
        }
      if(order_profit <  NormalizeDouble(be_profit*order_point,order_digits)) continue;
      if(order_profit <= stoplevel)
        {
         if(WriteDebugLog) WriteFileLogs(fhandle_logs,StringConcatenate("WatchMoveSLToBEMC: ticket ",DoubleToStr(order_ticket,0)," = it is impossible to move, the level stop-loss is near to the close price."));
         continue;
        }
      if(WriteDebugLog) WriteFileLogs(fhandle_logs,StringConcatenate("WatchMoveSLToBEMC: order_ticket = ",DoubleToStr(order_ticket,0),",  new_stop_loss = ",DoubleToStr(new_stop_loss,8)));
      OrderModifyEx(order_ticket,order_open_price,new_stop_loss,order_take_profit,0,ColorMove,"WatchMoveSLToBEMC");
     }
  }

//---------------------------------------------------------------------------------------------+
//---- WatchOrderLevelsMC ---------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
void WatchOrderLevelsMC(double tp_points, double sl_points, int magic_number, string wl_symbol = "")
  {
   if(StringLen(wl_symbol) <= 0) bool check_order_symbol = false;
   else check_order_symbol = true;
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("WatchOrderLevelsMC: OrderSelect() error = ",ErrorDescription(GetLastError())));
         continue;
        }
      int order_magic_number = OrderMagicNumber();
      if(magic_number >= 0) if(order_magic_number != magic_number) continue;
      string order_symbol = OrderSymbol();
      if(check_order_symbol) if(order_symbol != wl_symbol) continue;
      int order_digits = MarketInfo(order_symbol,MODE_DIGITS);
      double order_point = MarketInfo(order_symbol,MODE_POINT);
      double stoplevel = NormalizeDouble(MarketInfo(order_symbol,MODE_STOPLEVEL) * order_point,order_digits);
      int order_type = OrderType();
      int order_ticket = OrderTicket();
      double order_lots = NormalizeDouble(OrderLots(),lots_digits);
      double order_open_price  = NormalizeDouble(OrderOpenPrice(), order_digits);
      double order_stop_loss   = NormalizeDouble(OrderStopLoss(),  order_digits);
      double order_close_price = NormalizeDouble(OrderClosePrice(),order_digits);
      double order_take_profit = NormalizeDouble(OrderTakeProfit(),order_digits);
      if(order_type == OP_BUY)
        {
         double profit = NormalizeDouble(order_close_price - order_open_price,order_digits);
         color order_color = ColorBuy;
        }
      else
        {
         profit = NormalizeDouble(order_open_price - order_close_price,order_digits);
         order_color = ColorSell;
        }
      if(sl_points < 0 && profit <= NormalizeDouble(sl_points*order_point,order_digits))
        {
         if(WriteDebugLog) WriteFileLogs(fhandle_logs,StringConcatenate("WatchOrderLevelsMC: level s/l for close ",OrderTypeToStr(order_type),",",DoubleToStr(order_ticket,0)));
         OrderCloseEx(order_ticket,OrderLots(),order_close_price,slippage,order_color,"WatchOrderLevelsMC");
        }
      else
        {
         if(tp_points > 0 && profit >= NormalizeDouble(tp_points*order_point,order_digits))
           {
            if(WriteDebugLog) WriteFileLogs(fhandle_logs,StringConcatenate("WatchOrderLevelsMC: level t/p for close ",OrderTypeToStr(order_type),",",DoubleToStr(order_ticket,0)));
            OrderCloseEx(order_ticket,order_lots,order_close_price,slippage,order_color,"WatchOrderLevelsMC");
           }
        }
     }
  }

//---------------------------------------------------------------------------------------------+
//---- SetOrderLevelsMC -----------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
void SetOrderLevelsMC(double tp_points, double sl_points, int magic_number, string sl_symbol = "")
  {
   if(StringLen(sl_symbol) <= 0) bool check_order_symbol = false;
   else check_order_symbol = true;
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("SetOrderLevelsMC: OrderSelect() error = ",ErrorDescription(GetLastError())));
         continue;
        }
      if(magic_number >= 0) if(OrderMagicNumber() != magic_number) continue;
      string order_symbol = OrderSymbol();
      if(check_order_symbol) if(order_symbol != sl_symbol) continue;
      int order_digits = MarketInfo(order_symbol,MODE_DIGITS);
      double order_point = MarketInfo(order_symbol,MODE_POINT);
      double stoplevel = NormalizeDouble(MarketInfo(order_symbol,MODE_STOPLEVEL) * order_point,order_digits);
      int order_type = OrderType();
      int order_ticket = OrderTicket();
      double order_lots = NormalizeDouble(OrderLots(),lots_digits);
      double order_open_price  = NormalizeDouble(OrderOpenPrice(), order_digits);
      double order_stop_loss   = NormalizeDouble(OrderStopLoss(),  order_digits);
      double order_close_price = NormalizeDouble(OrderClosePrice(),order_digits);
      double order_take_profit = NormalizeDouble(OrderTakeProfit(),order_digits);
      if(order_type > OP_SELL)
        {
         if(NormalizeDouble(MathAbs(order_open_price - order_close_price),order_digits) <= stoplevel) continue;
        }
      bool to_modify_sl = false;
      bool to_modify_tp = false;
      if(order_stop_loss == 0)
        {
         if(sl_points < 0)
           {
            if((order_type % 2) == OP_BUY)
              {
               double new_stoploss = NormalizeDouble(order_open_price + sl_points*order_point,order_digits);
               if(NormalizeDouble(order_close_price - new_stoploss,order_digits) > stoplevel) to_modify_sl = true;
               else new_stoploss = order_stop_loss;
              }
            else
              {
               new_stoploss = NormalizeDouble(order_open_price - sl_points*order_point,order_digits);
               if(NormalizeDouble(new_stoploss - order_close_price,order_digits) > stoplevel) to_modify_sl = true;
               else new_stoploss = order_stop_loss;
              }
           }
         else new_stoploss = order_stop_loss;
        }
      else new_stoploss = order_stop_loss;
      if(order_take_profit == 0)
        {
         if(tp_points > 0)
           {
            if((order_type % 2) == OP_BUY)
              {
               double new_takeprofit = NormalizeDouble(order_open_price + tp_points*order_point,order_digits);
               if(NormalizeDouble(new_takeprofit - order_close_price,order_digits) > stoplevel) to_modify_tp = true;
               else new_takeprofit = order_take_profit;
              }
            else
              {
               new_takeprofit = NormalizeDouble(order_open_price - tp_points*order_point,order_digits);
               if(NormalizeDouble(order_close_price - new_takeprofit,order_digits) > stoplevel) to_modify_tp = true;
               else new_takeprofit = order_take_profit;
              }
           }
         else new_takeprofit = order_take_profit;
        }
      else new_takeprofit = order_take_profit;
      if(to_modify_sl || to_modify_tp)
        {
         if((order_type % 2) == OP_BUY) color order_color = ColorBuy;
         else order_color = ColorSell;
         OrderModifyEx(order_ticket,order_open_price,new_stoploss,new_takeprofit,0,order_color,"SetOrderLevelsMC");
        }
     }
  }

//---------------------------------------------------------------------------------------------+
//---- WatchSaveOrdersHistoryMC ---------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
void WatchSaveOrdersHistoryMC(int magic_number, string soh_symbol = "")
  {
   if(StringLen(soh_symbol) <= 0) bool check_order_symbol = false;
   else check_order_symbol = true;
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("WatchSaveOrdersHistoryMC: OrderSelect() error = ",ErrorDescription(GetLastError())));
         continue;
        }
      if(magic_number >= 0) if(OrderMagicNumber() != magic_number) continue;
      if(check_order_symbol) if(OrderSymbol() != soh_symbol) continue;
      int order_ticket = OrderTicket();
      for(int j=0; j<NumberTicketsInArray; j++)
        {
         if(OpenedOrders[j] == order_ticket) break;
         if(OpenedOrders[j] < 0)
           {
            OpenedOrders[j] = order_ticket;
            OpenedOrders_Latency[j] = -1;
            break;
           }
        }
     }
   bool modify_array = false;
   for(i=0; i<NumberTicketsInArray; i++)
     {
      if(OpenedOrders[i] < 0) break;
      int order_status = OrderStatus(OpenedOrders[i]);
      if(order_status >= 2)
        {
         WriteOrdersHistory(OpenedOrders[i],i);
         modify_array = true;
        }
     }
   if(modify_array)
     {
      j = 0;
      for(i=0; i<NumberTicketsInArray; i++)
        {
         if(OpenedOrders[i] >= 0)
           {
            if(i != j)
              {
               OpenedOrders[j] = OpenedOrders[i];
               OpenedOrders_Latency[j] = OpenedOrders_Latency[i];
               OpenedOrders[i] = -1;
              }
            j++;
           }
        }
     }
  }

//---------------------------------------------------------------------------------------------+
//---- OrderStatus ----------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
int OrderStatus(int order_ticket)
  {
   if(order_ticket < 0) return(-1);
   if(OrderSelect(order_ticket,SELECT_BY_TICKET))
     {
      int order_type = OrderType();
      if(OrderCloseTime() != 0)
        {
         if(order_type > OP_SELL) return(2);
         int order_digits = MarketInfo(OrderSymbol(),MODE_DIGITS);
         double order_open_price  = NormalizeDouble(OrderOpenPrice(), order_digits);
         double order_close_price = NormalizeDouble(OrderClosePrice(),order_digits);
         double order_stop_loss   = NormalizeDouble(OrderStopLoss(),  order_digits);
         double order_take_profit = NormalizeDouble(OrderTakeProfit(),order_digits);
         if(order_type == OP_BUY)
           {
            double order_profit = NormalizeDouble(order_close_price - order_open_price,order_digits);
            if(order_close_price <= order_stop_loss && order_stop_loss != 0 && order_profit < 0) return(3);
            if(order_close_price >= order_take_profit && order_take_profit != 0 && order_profit > 0) return(4);
            if(order_profit >= 0) return(5);
            return(6);
           }
         else
           {
            order_profit = NormalizeDouble(order_open_price - order_close_price,order_digits);
            if(order_close_price >= order_stop_loss && order_stop_loss != 0 && order_profit < 0) return(3);
            if(order_close_price <= order_take_profit && order_take_profit != 0 && order_profit > 0) return(4);
            if(order_profit >= 0) return(5);
            return(6);
           }
        }
      if(order_type > OP_SELL) return(0);
      return(1);
     }
   if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("OrderStatus: OrderSelect(",DoubleToStr(order_ticket,0),"), error = ",ErrorDescription(GetLastError())));
   return(-1);
  }

//---------------------------------------------------------------------------------------------+
//---- WriteOrdersHistory ---------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
bool WriteOrdersHistory(int order_ticket, int array_index = -1)
  {
   bool result = false;
#define number_attempts_save_select 3
   int counter_attempts_select = 0;
   while(counter_attempts_select < number_attempts_save_select)
     {
      if(OrderSelect(order_ticket,SELECT_BY_TICKET))
        {
         if(array_index < 0) string latency_at_open = "unknown";
         else
           {
            if(OpenedOrders_Latency[array_index] < 0) latency_at_open = "unknown";
            else latency_at_open = DoubleToStr(OpenedOrders_Latency[array_index],0);
           }
         int num_chars = FileWrite(fhandle_ordershistory,OrderTicket(),
                                                         TimeToStr(OrderOpenTime(),TIME_DATE|TIME_MINUTES|TIME_SECONDS),
                                                         OrderTypeToStr(OrderType()),
                                                         OrderLots(),
                                                         OrderSymbol(),
                                                         OrderOpenPrice(),
                                                         OrderStopLoss(),
                                                         OrderTakeProfit(),
                                                         TimeToStr(OrderCloseTime(),TIME_DATE|TIME_MINUTES|TIME_SECONDS),
                                                         OrderClosePrice(),
                                                         OrderCommission(),
                                                         OrderSwap(),
                                                         OrderProfit(),
                                                         OrderMagicNumber(),
                                                         OrderComment(),
                                                         latency_at_open
                                  );
         if(num_chars < 0)
           {
            if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("WriteOrdersHistory: FileWrite(",fhandle_ordershistory,"), ticket = ",DoubleToStr(order_ticket,0),", error = ",ErrorDescription(GetLastError())));
           }
         else
           {
            FileFlush(fhandle_ordershistory);
            result = true;
            break;
           }
        }
      Sleep(1000);
      counter_attempts_select++;
     }
   if(!result)
     {
      if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("WriteOrdersHistory: can not select an order, ticket = ",DoubleToStr(order_ticket,0),", error = ",ErrorDescription(GetLastError())));
      return(result);
     }
   if(array_index >= 0) OpenedOrders[array_index] = -1;
   else
     {
      for(int i=0; i<NumberTicketsInArray; i++)
        {
         if(OpenedOrders[i] < 0) break;
         if(OpenedOrders[i] == order_ticket)
           {
            OpenedOrders[i] = -1;
            break;
           }
        }
      int j = 0;
      for(i=0; i<NumberTicketsInArray; i++)
        {
         if(OpenedOrders[i] >= 0)
           {
            if(i != j)
              {
               OpenedOrders[j] = OpenedOrders[i];
               OpenedOrders_Latency[j] = OpenedOrders_Latency[i];
               OpenedOrders[i] = -1;
              }
            j++;
           }
        }
     }
   return(result);
  }

//---------------------------------------------------------------------------------------------+
//---- OrderModifyEx --------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
bool OrderModifyEx(int order_ticket, double new_open_price, double new_stop_loss, double new_take_profit, datetime new_expiration = -1, color order_color = CLR_NONE, string parent_fun_name = "")
  {
#define number_attempts_modify          3
#define number_attempts_modify_select   3
#define number_attempts_modify_wait     30
   int err_129 = 0;
   int err_130 = 0;
   int err_137 = 0;
   int err_138 = 0;
   int err_145 = 0;
   if(StringLen(parent_fun_name) > 0) parent_fun_name = StringConcatenate(parent_fun_name," -> ");
   while(true)
     {
      if(!IsExpertEnabled())
        {
         bool error = false;
         break;
        }
      RefreshRates();
      int counter_attempts_select = 0;
      while(counter_attempts_select < number_attempts_modify_select)
        {
         if(OrderSelect(order_ticket,SELECT_BY_TICKET)) break;
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate(parent_fun_name,"OrderModifyEx: OrderSelect() error = ",ErrorDescription(GetLastError())));
         Sleep(1000);
         counter_attempts_select++;
        }
      if(counter_attempts_select >= number_attempts_modify_select)
        {
         error = false;
         break;
        }
      if(OrderCloseTime() != 0) 
        {
         error = true;
         break;
        }
      string order_symbol = OrderSymbol();
      int order_type = OrderType();
      int order_digits = MarketInfo(order_symbol,MODE_DIGITS);
      new_open_price  = NormalizeDouble(new_open_price, order_digits);
      new_stop_loss   = NormalizeDouble(new_stop_loss,  order_digits);
      new_take_profit = NormalizeDouble(new_take_profit,order_digits);
      double order_open_price  = NormalizeDouble(OrderOpenPrice(), order_digits);
      double order_close_price = NormalizeDouble(OrderClosePrice(),order_digits);
      double order_stop_loss   = NormalizeDouble(OrderStopLoss(),  order_digits);
      double order_take_profit = NormalizeDouble(OrderTakeProfit(),order_digits);
      datetime order_expiration = OrderExpiration();
      double stoplevel = NormalizeDouble(MarketInfo(order_symbol,MODE_STOPLEVEL)*MarketInfo(order_symbol,MODE_POINT),order_digits);
      bool to_modify = false;
      if(order_type > OP_SELL)
        {
         if(new_open_price < 0 || new_open_price == order_open_price)
           {
            double modify_open_price = order_open_price;
            if(NormalizeDouble(MathAbs(modify_open_price - order_close_price),order_digits) < stoplevel)
              {
               error = false;
               break;
              }
           }
         else
           {
            modify_open_price = new_open_price;
            to_modify = true;
            bool to_modify2 = true;
            switch(order_type)
              {
               case OP_BUYLIMIT:
               case OP_SELLSTOP:
                  if(NormalizeDouble(order_close_price - modify_open_price,order_digits) < stoplevel) to_modify2 = false;
                  break;
               case OP_BUYSTOP:
               case OP_SELLLIMIT:
                  if(NormalizeDouble(modify_open_price - order_close_price,order_digits) < stoplevel) to_modify2 = false;
                  break;
              }
            if(!to_modify2)
              {
               error = false;
               break;
              }
           }
         if(new_expiration < 0 || new_expiration == order_expiration) double modify_expiration = order_expiration;
         else
           {
            modify_expiration = new_expiration;
            to_modify = true;
           }
         double second_price = modify_open_price;
        }
      else
        {
         modify_open_price = order_open_price;
         modify_expiration = order_expiration;
         second_price = order_close_price;
        }
      if(new_stop_loss < 0 || new_stop_loss == order_stop_loss) double modify_stop_loss = order_stop_loss;
      else
        {
         modify_stop_loss = new_stop_loss;
         to_modify = true;
        }
      if(new_take_profit < 0 || new_take_profit == order_take_profit) double modify_take_profit = order_take_profit;
      else
        {
         modify_take_profit = new_take_profit;
         to_modify = true;
        }
      if(!to_modify)
        {
         error = true;
         break;
        }
      if((order_type % 2) == OP_BUY)
        {
         if(modify_stop_loss != 0 && NormalizeDouble(second_price - modify_stop_loss,order_digits) < stoplevel)
           {
            error = false;
            break;
           }
         if(modify_take_profit != 0 && NormalizeDouble(modify_take_profit - second_price,order_digits) < stoplevel)
           {
            error = false;
            break;
           }
        }
      else
        {
         if(modify_stop_loss != 0 && NormalizeDouble(modify_stop_loss - second_price,order_digits) < stoplevel)
           {
            error = false;
            break;
           }
         if(modify_take_profit != 0 && NormalizeDouble(second_price - modify_take_profit,order_digits) < stoplevel)
           {
            error = false;
            break;
           }
        }
      for(int i=0; i<number_attempts_modify_wait; i++)
        {
         if(!IsTradeContextBusy()) break;
         Sleep(1000);
        }
      if(i >= number_attempts_modify_wait) continue;
      GetLastError();
      error = OrderModify(order_ticket,modify_open_price,modify_stop_loss,modify_take_profit,modify_expiration,order_color);
      if(!error)
        {
         int err = GetLastError();
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate(parent_fun_name,"OrderModifyEx(",OrderTypeToStr(order_type),",",order_ticket,"): ",ErrorDescription(err)));
         bool cont = false;
         switch(err)
           {
            case    0:
               Sleep(10000);
               cont = true;
               break;
            case    6:
               Sleep(10000);
               if(IsConnected()) cont = true;
               break;
            case  128:
               Sleep(70000);
               cont = true;
               break;
            case  129:
               Sleep(6000);
               err_129++;
               if(err_129 <= number_attempts_modify) cont = true;
               break;
            case  130:
               Sleep(6000);
               err_130++;
               if(err_130 <= number_attempts_modify) cont = true;
               break;
            case  134:
               Sleep(6000);
               cont = true;
               break;
            case  135:
               cont = true;
               break;
            case  136:
               Sleep(6000);
               cont = true;
               break;
            case  137:
               Sleep(20000);
               err_137++;
               if(err_137 <= number_attempts_modify) cont = true;
               break;
            case  138:
               err_138++;
               if(err_138 <= number_attempts_modify) cont = true;
               break;
            case  142:
               Sleep(70000);
               cont = true;
               break;
            case  143:
               Sleep(70000);
               cont = true;
               break;
            case  145:
               Sleep(20000);
               err_145++;
               if(err_145 <= number_attempts_modify) cont = true;
               break;
            case  146:
               while(IsTradeContextBusy()) Sleep(1000);
               cont = true;
               break;
            case  147:
               new_expiration = 0;
               cont = true;
               break;
            case 4000:
               Sleep(10000);
               cont = true;
               break;
           }
         if(!cont) break;
        }
      else
        {
         if(CreateScreenshots) CreateScreenshot();
         if(play_sound_at_modify) PlaySound(SoundFileAtModify);
         if(WriteLog && WriteToSeparateLogFile)
           {
            counter_attempts_select = 0;
            while(counter_attempts_select < number_attempts_modify_select)
              {
               if(OrderSelect(OrderTicket(),SELECT_BY_TICKET))
                 {
                  string order_print = StringConcatenate("modify #",DoubleToStr(OrderTicket(),0)," ",
                                                         StringSubstr(OrderSymbol(),0,6)," ",OrderTypeToStr(OrderType())," ",
                                                         DoubleToStr(OrderLots(),lots_digits),
                                                         " OP = ",DoubleToStr(OrderOpenPrice(),order_digits),
                                                         " OT = ",TimeToStr(OrderOpenTime(),TIME_DATE|TIME_MINUTES|TIME_SECONDS),
                                                         " SL = ",DoubleToStr(OrderStopLoss(),order_digits),
                                                         " TP = ",DoubleToStr(OrderTakeProfit(),order_digits),
                                                         ", [",DoubleToStr(OrderMagicNumber(),0),"] \"",OrderComment(),"\""
                                                        );
                  WriteFileLogs(fhandle_logs,order_print);
                  break;
                 }
               if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("OrderModifyEx: OrderSelect() error = ",ErrorDescription(GetLastError())));
               Sleep(1000);
               counter_attempts_select++;
              }
           }
         break;
        }
     }
   return(error);
  }

//---------------------------------------------------------------------------------------------+
//---- OrderCloseEx ---------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
bool OrderCloseEx(int order_ticket, double order_lots, double order_close_price, int order_slippage, color order_color = CLR_NONE, string parent_fun_name = "")
  {
#define number_attempts_close           3
#define number_attempts_close_select    3
#define number_attempts_close_wait      30
   if(StringLen(parent_fun_name) > 0) parent_fun_name = StringConcatenate(parent_fun_name," -> ");
   int err_129 = 0;
   int err_130 = 0;
   int err_137 = 0;
   int err_138 = 0;
   while(true)
     {
      if(!IsExpertEnabled())
        {
         bool error = false;
         break;
        }
      RefreshRates();
      int counter_attempts_select = 0;
      while(counter_attempts_select < number_attempts_close_select)
        {
         if(OrderSelect(order_ticket,SELECT_BY_TICKET))
           {
            int order_digits = MarketInfo(OrderSymbol(),MODE_DIGITS);
            break;
           }
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate(parent_fun_name,"OrderCloseEx: OrderSelect() error = ",ErrorDescription(GetLastError())));
         Sleep(1000);
         counter_attempts_select++;
        }
      if(counter_attempts_select >= number_attempts_close_select)
        {
         error = false;
         break;
        }
      if(OrderCloseTime() != 0) 
        {
         error = true;
         break;
        }
      int order_type = OrderType();
      for(int i=0; i<number_attempts_close_wait; i++)
        {
         if(!IsTradeContextBusy()) break;
         Sleep(1000);
        }
      if(i >= number_attempts_close_wait) continue;
      GetLastError();
      order_close_price = NormalizeDouble(OrderClosePrice(),order_digits);
      error = OrderClose(order_ticket,order_lots,order_close_price,order_slippage,order_color);
      if(!error)
        {         
         int err = GetLastError();
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate(parent_fun_name,"OrderCloseEx(",OrderTypeToStr(order_type),",",DoubleToStr(order_ticket,0),") error = ",ErrorDescription(err)));
         bool cont = false;
         switch(err)
           {
            case    0:
               Sleep(10000);
               if(OrderSelect(order_ticket,SELECT_BY_TICKET)) if(OrderCloseTime() == 0) cont = true;
               break;
            case    6:
               Sleep(10000);
               if(IsConnected()) cont = true;
               break;
            case  128:
               Sleep(70000);
               if(OrderSelect(order_ticket,SELECT_BY_TICKET)) if(OrderCloseTime() == 0) cont = true;
               break;
            case  129:
               Sleep(6000);
               err_129++;
               if(err_129 <= number_attempts_close) cont = true;
               break;
            case  130:
               Sleep(6000);
               err_130++;
               if(err_130 <= number_attempts_close) cont = true;
               break;
            case  135:
               cont = true;
               break;
            case  136:
               Sleep(6000);
               cont = true;
               break;
            case  137:
               Sleep(20000);
               err_137++;
               if(err_137 <= number_attempts_close) cont = true;
               break;
            case  138:
               err_138++;
               if(err_138 <= number_attempts_close) cont = true;
               break;
            case  142:
               Sleep(70000);
               if(OrderSelect(order_ticket,SELECT_BY_TICKET)) if(OrderCloseTime() == 0) cont = true;
               break;
            case  143:
               Sleep(70000);
               if(OrderSelect(order_ticket,SELECT_BY_TICKET)) if(OrderCloseTime() == 0) cont = true;
               break;
            case  145:
               Sleep(20000);
               cont = true;
               break;
            case  146:
               while(IsTradeContextBusy()) Sleep(1000);
               cont = true;
               break;
            case 4000:
               Sleep(10000);
               if(OrderSelect(order_ticket,SELECT_BY_TICKET)) if(OrderCloseTime() == 0) cont = true;
               break;
           }
         if(!cont) break;
        }
      else
        {
         if(CreateScreenshots) CreateScreenshot();
         if(OrderSelect(order_ticket,SELECT_BY_TICKET)) order_close_price = OrderClosePrice();
         if(SendEmail) SendMail(EmailSubjectClose,StringConcatenate(ExpertName," EA Trade Information\nCurrency Pair: ",StringSubstr(OrderSymbol(),0,6),"\nTime: ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS),"\nOrder Type: ",OrderTypeToStr(order_type),"\nPrice: ",DoubleToStr(order_close_price,MarketInfo(OrderSymbol(),MODE_DIGITS)),"\nLot size: ",DoubleToStr(order_lots,lots_digits),"\nEvent: Trade Closed","\n\nCurrent Balance: ",DoubleToStr(AccountBalance(),2)," ",account_currency,"\nCurrent Equity: ",DoubleToStr(AccountEquity(),2)," ",account_currency));
         if(play_sound_at_close) PlaySound(SoundFileAtClose);
         if(WriteLog && WriteToSeparateLogFile)
           {
            counter_attempts_select = 0;
            while(counter_attempts_select < number_attempts_close_select)
              {
               if(OrderSelect(order_ticket,SELECT_BY_TICKET))
                 {
                  string order_print = StringConcatenate("close #",DoubleToStr(OrderTicket(),0)," ",
                                                         StringSubstr(OrderSymbol(),0,6)," ",OrderTypeToStr(OrderType())," ",
                                                         DoubleToStr(OrderLots(),lots_digits),
                                                         " CP = ",DoubleToStr(OrderClosePrice(),order_digits),
                                                         " CT = ",TimeToStr(OrderCloseTime(),TIME_DATE|TIME_MINUTES|TIME_SECONDS)," ",
                                                         " OP = ",DoubleToStr(OrderOpenPrice(),order_digits),
                                                         " OT = ",TimeToStr(OrderOpenTime(),TIME_DATE|TIME_MINUTES|TIME_SECONDS),
                                                         " SL = ",DoubleToStr(OrderStopLoss(),order_digits),
                                                         " TP = ",DoubleToStr(OrderTakeProfit(),order_digits),
                                                         ", [",DoubleToStr(OrderMagicNumber(),0),"] \"",OrderComment(),"\""
                                                        );
                  WriteFileLogs(fhandle_logs,order_print);
                  WriteFileLogs(fhandle_logs,StringConcatenate("order profit = ",DoubleToStr(OrderProfit() + OrderSwap() + OrderCommission(),2)," ",account_currency));
                  break;
                 }
               if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("OrderCloseEx: OrderSelect() error = ",ErrorDescription(GetLastError())));
               Sleep(1000);
               counter_attempts_select++;
              }
           }
         break;
        }
     }
   return(error);
  }

//---------------------------------------------------------------------------------------------+
//---- ClosePositionsMC -----------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
int ClosePositionsMC(int cmd, int magic_number, string cp_symbol = "", string parent_fun_name = "")
  {
   if(StringLen(cp_symbol) <= 0) bool check_order_symbol = false;
   else check_order_symbol = true;
   if(StringLen(parent_fun_name) > 0) parent_fun_name = StringConcatenate(parent_fun_name," -> ","ClosePositionsMC");
   else parent_fun_name = "ClosePositionsMC";
   int num_pos = 0;
   int num_errors = 0;
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate(parent_fun_name,": OrderSelect() error = ",ErrorDescription(GetLastError())));
         num_errors--;
         continue;
        }
      if(OrderMagicNumber() != magic_number) continue;
      if(check_order_symbol) if(OrderSymbol() != cp_symbol) continue;
      int order_type = OrderType();
      if(order_type > OP_SELL) continue;
      if(order_type != cmd) continue;
      if((order_type % 2) == OP_BUY) color order_color = ColorBuy;
      else order_color = ColorSell;
      bool error = OrderCloseEx(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,order_color,parent_fun_name);
      if(!error) num_errors--;
      else num_pos++;
     }
   if(num_errors != 0) return(num_errors);
   return(num_pos);
  }

//---------------------------------------------------------------------------------------------+
//---- HavePositionsMC ------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
int HavePositionsMC(int cmd, int magic_number, string hp_symbol = "", string parent_fun_name = "")
  {
   if(StringLen(hp_symbol) <= 0) bool check_order_symbol = false;
   else check_order_symbol = true;
   if(StringLen(parent_fun_name) > 0) parent_fun_name = StringConcatenate(parent_fun_name," -> ","HavePositionsMC");
   else parent_fun_name = "HavePositionsMC";
   int num_pos = 0;
   int num_errors = 0;
   int total = OrdersTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate(parent_fun_name,": OrderSelect() error = ",ErrorDescription(GetLastError())));
         num_errors--;
         continue;
        }
      if(OrderMagicNumber() != magic_number) continue;
      if(check_order_symbol) if(OrderSymbol() != hp_symbol) continue;
      int order_type = OrderType();
      if(order_type > OP_SELL) continue;
      if(order_type != cmd) continue;
      num_pos++;
     }
   if(num_errors != 0) return(num_errors);
   return(num_pos);
  }

//---------------------------------------------------------------------------------------------+
//---- OpenOrderMC ----------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
int OpenOrderMC(int order_type, int magic_number, string order_comment, double order_lots, double open_price=0, string order_symbol = "", string parent_fun_name = "")
  {
   if(order_type > OP_SELL && open_price <= 0) return(-1);
   if(StringLen(order_symbol) <= 0) order_symbol = symbol;
   if(StringLen(parent_fun_name) > 0) parent_fun_name = StringConcatenate(parent_fun_name," -> ","OpenOrderMC");
   else parent_fun_name = "OpenOrderMC";
   int order_direction = order_type % 2;
   if(order_lots < minlots) order_lots = minlots;
   else if(order_lots > maxlots) order_lots = maxlots;
   if(AccountFreeMarginCheck(order_symbol,order_direction,order_lots) <= 0 || GetLastError() == 134)
     {
      Print(StringConcatenate(parent_fun_name,": you don\'t have a free margin."));
      return(-1);
     }
   if(order_direction == OP_BUY) color cmd_color = ColorBuy;
   else cmd_color = ColorSell;
   RefreshRates();
   int order_digits = MarketInfo(order_symbol,MODE_DIGITS);
   double order_point = MarketInfo(order_symbol,MODE_POINT);
   double stoplevel = NormalizeDouble(MarketInfo(order_symbol,MODE_STOPLEVEL) * order_point,order_digits);
   double bid = NormalizeDouble(MarketInfo(order_symbol,MODE_BID),order_digits);
   double ask = NormalizeDouble(MarketInfo(order_symbol,MODE_ASK),order_digits);
   switch(order_type)
     {
      case OP_BUY:
         open_price = ask;
         break;
      case OP_SELL:
         open_price = bid;
         break;
      case OP_BUYLIMIT:
         if(open_price >= ask)
           {
            open_price = ask;
            order_type = OP_BUY;
           }
         else if(NormalizeDouble(ask - open_price,order_digits) < stoplevel) return(-1);
         break;
      case OP_SELLLIMIT:
         if(open_price <= bid)
           {
            open_price = bid;
            order_type = OP_SELL;
           }
         else if(NormalizeDouble(open_price - bid,order_digits) < stoplevel) return(-1);
         break;
      case OP_BUYSTOP:
         if(open_price <= ask)
           {
            open_price = ask;
            order_type = OP_BUY;
           }
         else if(NormalizeDouble(open_price - ask,order_digits) < stoplevel) return(-1);
         break;
      case OP_SELLSTOP:
         if(open_price >= bid)
           {
            open_price = bid;
            order_type = OP_SELL;
           }
         else if(NormalizeDouble(bid - open_price,order_digits) < stoplevel) return(-1);
         break;
      default:
         return(-1);
         break;
     }
   int ticket = OrderSendEx(order_symbol,order_type,order_lots,open_price,slippage,0,0,order_comment,magic_number,0,cmd_color,parent_fun_name);
   return(ticket);
  }
  
//---------------------------------------------------------------------------------------------+
//---- OrderSendEx ----------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
int OrderSendEx(string order_symbol, int order_type, double order_lots, double order_open_price, int order_slippage, double order_stop_loss, double order_take_profit, string order_comment = "", int order_magic_number = 0, datetime order_expiration = 0, color order_color = CLR_NONE, string parent_fun_name = "")
  {
#define number_attempts_send        3
#define number_attempts_send_select 3
   int err_129  = 0;
   int err_130  = 0;
   int err_137  = 0;
   int err_138  = 0;
   int err_4107 = 0;
   if(StringLen(parent_fun_name) > 0) parent_fun_name = StringConcatenate(parent_fun_name," -> ");
   if(order_symbol == "") order_symbol = symbol;
   int order_digits  = MarketInfo(order_symbol,MODE_DIGITS);
   order_open_price  = NormalizeDouble(order_open_price,order_digits);
   order_stop_loss   = NormalizeDouble(order_stop_loss,order_digits);
   order_take_profit = NormalizeDouble(order_take_profit,order_digits);
   int start_tick_count = GetTickCount();
   while(true)
     {
      if(!IsExpertEnabled())
        {
         int ticket = -1;
         break;
        }
      RefreshRates();
      double ask = NormalizeDouble(MarketInfo(order_symbol,MODE_ASK),order_digits);
      double bid = NormalizeDouble(MarketInfo(order_symbol,MODE_BID),order_digits);
      double stoplevel = NormalizeDouble(MarketInfo(order_symbol,MODE_STOPLEVEL)*MarketInfo(order_symbol,MODE_POINT),order_digits);
      if(order_type > OP_SELL)
        {
         if(order_open_price <= 0)
           {
            ticket = -1;
            break;
           }
         if((order_type % 2) == OP_BUY) double current_price = ask;
         else current_price = bid;
         switch(order_type)
           {
            case OP_BUYLIMIT:
            case OP_SELLSTOP:
               double distance = NormalizeDouble(current_price - order_open_price,order_digits);
               break;
            case OP_BUYSTOP:
            case OP_SELLLIMIT:
               distance = NormalizeDouble(order_open_price - current_price,order_digits);
               break;
           }
         if(distance < stoplevel)
           {
            if(WriteLog)
              {
               if(distance < 0) WriteFileLogs(fhandle_logs,StringConcatenate(parent_fun_name,"OrderSendEx: The position of open price order does not correspond to type of the order."));
               else WriteFileLogs(fhandle_logs,StringConcatenate(parent_fun_name,"OrderSendEx: It is impossible to open the order (the open price is near to the current price)."));
              }
            ticket = -1;
            break;
           }
         if(order_slippage < 0) order_slippage = 0;
        }
      else
        {
         if(order_type == OP_BUY)
           {
            if(order_open_price <= 0) order_open_price = ask;
           }
         else
           {
            if(order_open_price <= 0) order_open_price = bid;
           }
         if(order_slippage < 0) order_slippage = slippage;
        }
      if(order_stop_loss != 0)
        {
         if((order_type % 2) == OP_BUY) distance = NormalizeDouble(order_open_price - order_stop_loss,order_digits);
         else distance = NormalizeDouble(order_stop_loss - order_open_price,order_digits);
         if(distance < stoplevel)
           {
            if(WriteLog)
              {
               if(distance < 0) WriteFileLogs(fhandle_logs,StringConcatenate(parent_fun_name,"OrderSendEx: The position of stop-loss price order does not correspond to type of the order."));
               else WriteFileLogs(fhandle_logs,StringConcatenate(parent_fun_name,"OrderSendEx: It is impossible to open the order (stop-loss is near to the open price)."));
              }
            ticket = -1;
            break;
           }
        }
      if(order_take_profit != 0)
        {
         if((order_type % 2) == OP_BUY) distance = NormalizeDouble(order_take_profit - order_open_price,order_digits);
         else distance = NormalizeDouble(order_open_price - order_take_profit,order_digits);
         if(distance < stoplevel)
           {
            if(WriteLog)
              {
               if(distance < 0) WriteFileLogs(fhandle_logs,StringConcatenate(parent_fun_name,"OrderSendEx: The position of take-profit price order does not correspond to type of the order."));
               else WriteFileLogs(fhandle_logs,StringConcatenate(parent_fun_name,"OrderSendEx: It is impossible to open the order (take-profit is near to the open price)."));
              }
            ticket = -1;
            break;
           }
        }
      while(IsTradeContextBusy()) Sleep(1000);
      GetLastError();
      ticket = OrderSend(order_symbol,order_type,order_lots,order_open_price,order_slippage,order_stop_loss,order_take_profit,order_comment,order_magic_number,order_expiration,order_color);
      int finish_tick_count = GetTickCount();
      if(ticket < 0)
        {
         int err = GetLastError();
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate(parent_fun_name,"OrderSendEx: OrderSend(",OrderTypeToStr(order_type),") ",ErrorDescription(err)));
         bool cont = false;
         switch(err)
           {
            case    0:
               Sleep(10000);
               break;
            case    6:
               Sleep(10000);
               if(IsConnected()) cont = true;
               break;
            case  128:
               Sleep(70000);
               break;
            case  129:
               Sleep(6000);
               err_129++;
               if(err_129 <= number_attempts_send) cont = true;
               break;
            case  130:
               Sleep(6000);
               err_130++;
               if(err_130 <= number_attempts_send) cont = true;
               break;
            case  134:
               Sleep(6000);
               break;
            case  135:
               cont = true;
               break;
            case  136:
               Sleep(6000);
               cont = true;
               break;
            case  137:
               Sleep(20000);
               err_137++;
               if(err_137 <= number_attempts_send) cont = true;
               break;
            case  138:
               err_138++;
               if(err_138 <= number_attempts_send) cont = true;
               break;
            case  140:
               if((order_type % 2) == OP_BUY)  cont = true;
               break;
            case  142:
               Sleep(70000);
               break;
            case  143:
               Sleep(70000);
               break;
            case  146:
               while(IsTradeContextBusy()) Sleep(1000);
               cont = true;
               break;
            case  147:
               order_expiration = 0;
               cont = true;
               break;
            case 4000:
               Sleep(10000);
               break;
            case 4107:
               err_4107++;
               if(err_4107 <= number_attempts_send) cont = true;
               break;
            case 4110:
               if((order_type % 2) == OP_SELL) cont = true;
               break;
            case 4111:
               if((order_type % 2) == OP_BUY)  cont = true;
               break;
           }
         if(!cont) break;
        }
      else
        {
         if(finish_tick_count < start_tick_count) int latency = finish_tick_count;
         else latency = finish_tick_count - start_tick_count;
         for(int j=0; j<NumberTicketsInArray; j++)
           {
            if(OpenedOrders[j] == ticket)
              {
               OpenedOrders_Latency[j] = latency;
               break;
              }
            if(OpenedOrders[j] < 0)
              {
               OpenedOrders[j] = ticket;
               OpenedOrders_Latency[j] = latency;
               break;
              }
           }
         if(latency >= Latency)
           {
            slow_trades_counter++;
            if(WriteDebugLog) WriteFileLogs(fhandle_logs,"Have a slow trade!!!");
           }
         else slow_trades_counter = 0;
         if(CreateScreenshots) CreateScreenshot();
         if(OrderSelect(ticket,SELECT_BY_TICKET)) order_open_price = OrderOpenPrice();
         if(SendEmail) SendMail(EmailSubjectOpen,StringConcatenate(ExpertName," EA Trade Information\nCurrency Pair: ",StringSubstr(OrderSymbol(),0,6),"\nTime: ",TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS),"\nOrder Type: ",OrderTypeToStr(order_type),"\nPrice: ",DoubleToStr(order_open_price,MarketInfo(OrderSymbol(),MODE_DIGITS)),"\nLot size: ",DoubleToStr(order_lots,lots_digits),"\nEvent: Trade Opened","\n\nCurrent Balance: ",DoubleToStr(AccountBalance(),2)," ",account_currency,"\nCurrent Equity: ",DoubleToStr(AccountEquity(),2)," ",account_currency));
         if(play_sound_at_open) PlaySound(SoundFileAtOpen);
         if(WriteLog/* && WriteToSeparateLogFile*/)
           {
            int counter_attempts_select = 0;
            while(counter_attempts_select < number_attempts_send_select)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET))
                 {
                  if((order_type % 2) == OP_BUY) double order_open_price_diff = NormalizeDouble((order_open_price - OrderOpenPrice()) / point,pips_digits);
                  else order_open_price_diff = NormalizeDouble((OrderOpenPrice() - order_open_price) / point,pips_digits);
                  string order_print = StringConcatenate("open #",DoubleToStr(OrderTicket(),0)," ",
                                                         StringSubstr(OrderSymbol(),0,6)," ",OrderTypeToStr(OrderType())," ",
                                                         DoubleToStr(OrderLots(),lots_digits),
                                                         " OP = ",DoubleToStr(OrderOpenPrice(),order_digits),
                                                         " OT = ",TimeToStr(OrderOpenTime(),TIME_DATE|TIME_MINUTES|TIME_SECONDS),
                                                         " SL = ",DoubleToStr(OrderStopLoss(),order_digits),
                                                         " TP = ",DoubleToStr(OrderTakeProfit(),order_digits),
                                                         ", [",DoubleToStr(OrderMagicNumber(),0),"] \"",OrderComment(),"\"",
                                                         ", Latency = ",DoubleToStr(latency,0),
                                                         ", Requested = ",DoubleToStr(order_open_price,order_digits),
                                                         ", Slippage = ",DoubleToStr(order_open_price_diff,pips_digits),
                                                         ", Balance = ",DoubleToStr(AccountBalance(),2)
                                                        );
                  WriteFileLogs(fhandle_logs,order_print);
                  break;
                 }
               if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("OrderSendEx: OrderSelect() error = ",ErrorDescription(GetLastError())));
               Sleep(1000);
               counter_attempts_select++;
              }
           }
         break;
        }
     }
   return(ticket);
  }
  
//---------------------------------------------------------------------------------------------+
//---- LotsOptimized --------------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
double LotsOptimized(int cmd, string s_symbol="")
  {
   if(!UseMM) double lot = Lots;
   else
     {
      if(StringLen(s_symbol) <= 0) s_symbol = symbol;
      double MoneyForTrade = (AccountFreeMargin() * percent_freemargin) / 100.0;
      double MarginForLotStep = MarketInfo(s_symbol,MODE_MARGINREQUIRED) * lotstep;
      lot = NormalizeDouble(MathFloor(MoneyForTrade/MarginForLotStep)*lotstep,lots_digits);
     }
   if(lot > MaxLots) lot = MaxLots;
   if(lot < minlots)
     {
      lot = minlots;
      if(WriteDebugLog) WriteFileLogs(fhandle_logs,StringConcatenate("LotsOptimized: Calculated lots was replaced by minlots, calculated lots = ",DoubleToStr(lot,lots_digits)));
     }
   else
     {
      if(lot > maxlots)
        {
         lot = maxlots;
         if(WriteDebugLog) WriteFileLogs(fhandle_logs,StringConcatenate("LotsOptimized: Calculated lots was replaced by maxlots, calculated lots = ",DoubleToStr(lot,lots_digits)));
        }
     }
   return(lot);
  }

//---------------------------------------------------------------------------------------------+
//---- NumBarsAfterLastOrder ------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
int NumBarsAfterLastOrder(int magic_number, string nbalo_symbol = "")
  {
   if(StringLen(nbalo_symbol) <= 0) bool check_order_symbol = false;
   else check_order_symbol = true;
   int total = OrdersHistoryTotal();
   if(total == 0) return(-1);
   total--;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
        {
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("NumBarsAfterLastOrder: OrderSelect() error = ",ErrorDescription(GetLastError())));
         continue;
        }
      if(OrderMagicNumber() != magic_number) continue;
      if(check_order_symbol) if(OrderSymbol() != nbalo_symbol) continue;
      int num_bars = iBarShift(OrderSymbol(),0,OrderOpenTime());
      break;
     }
   return(num_bars);
  }

//---------------------------------------------------------------------------------------------+
//---- NumBarsAfterLastLoss -------------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
int NumBarsAfterLastLoss(int cmd, int magic_number, string nball_symbol = "")
  {
   if(StringLen(nball_symbol) <= 0) bool check_order_symbol = false;
   else check_order_symbol = true;
   int num_bars = -1;
   int total = OrdersHistoryTotal() - 1;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
        {
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("NumBarsAfterLastLoss: OrderSelect() error = ",ErrorDescription(GetLastError())));
         continue;
        }
      if(OrderMagicNumber() != magic_number) continue;
      if(check_order_symbol) if(OrderSymbol() != nball_symbol) continue;
      int order_type = OrderType();
      if(order_type > OP_SELL) continue;
      if(cmd >= 0) if(order_type != cmd) continue;
      if(order_type == OP_BUY) double profit = NormalizeDouble(OrderClosePrice() - OrderOpenPrice(),Digits);
      else profit = NormalizeDouble(OrderOpenPrice() - OrderClosePrice(),Digits);
      if(profit < 0) num_bars = iBarShift(OrderSymbol(),NULL,OrderCloseTime());
      break;
     }
   return(num_bars);
  }

//---------------------------------------------------------------------------------------------+
//---- CalculateTradeResultsMC ----------------------------------------------------------------+
//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+
//---------------------------------------------------------------------------------------------+
void CalculateTradeResultsMC(int magic_number, string ctr_symbol = "")
  {
   if(StringLen(ctr_symbol) <= 0) bool check_order_symbol = false;
   else check_order_symbol = true;
   int total = OrdersHistoryTotal();
   if(prev_orders_total_history == total) return;
   total--;
   TR_num_orders_loss   = 0;
   TR_num_orders_profit = 0;
   TR_gross_profit      = 0.0;
   for(int i=total; i>=0; i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
        {
         if(WriteLog) WriteFileLogs(fhandle_logs,StringConcatenate("CalculateTradeResultsMC: OrderSelect() error = ",ErrorDescription(GetLastError())));
         continue;
        }
      if(OrderMagicNumber() != magic_number) continue;
      if(OrderType() > OP_SELL) continue;
      if(check_order_symbol) if(OrderSymbol() != ctr_symbol) continue;
      if(OrderCloseTime() < TR_TimeAtStartEA) break;
      if(OrderOpenTime()  < TR_TimeAtStartEA) continue;
      double profit = OrderProfit() + OrderSwap() + OrderCommission();
      TR_gross_profit += profit;
      if(profit >= 0) TR_num_orders_profit++;
      else TR_num_orders_loss++;
     }
   return;
  }

//-------------------------------- programming by Serega Lykov, http://mtexperts.narod.ru/ ----+